import { c as J, a as K, t as Q, z as j, p as $, V as X, O as R, f as U, L as ee, G as te, i as ae, a4 as re, a1 as le, a5 as ie, v as se, a6 as ne, d as he, B as oe, b as ce, q as de, R as ue, a7 as ge, r as fe, e as Ie, a2 as me, y as Ne, C as xe, x as be, a8 as Fe, Z as _e, o as Ae, s as ye, w as Le, F as Ce, A as Se, u as ke } from "./index-CsThtcFA.js";
import { D as we } from "./DataTable-dr19AFlT.js";
import { _ as Oe } from "./Title-BcYvD5u3.js";
import { _ as Ge, u as ve } from "./Tooltip-CnEP60Ez.js";
import { U as ze } from "./usePrinter-CHJnz2qB.js";
import { _ as Me } from "./Shape-C8l-pKBy.js";
import pe from "./BaseIcon-DIxHp0nP.js";
import Ve from "./vue-ui-table-sparkline-BBC4lVJM.js";
import Te from "./vue-ui-skeleton-nkyhyXuS.js";
import { S as Pe } from "./Slicer-CA7iwke8.js";
import Re from "./vue-ui-accordion-R1MtUDWQ.js";
import { u as Z } from "./useNestedProp-CYmg6HKV.js";
import { _ as De } from "./PackageVersion-6TSHlmr5.js";
import { P as He } from "./PenAndPaper-C5Ug24R7.js";
import { resolveComponent as T, openBlock as l, createElementBlock as i, normalizeClass as P, normalizeStyle as L, createBlock as D, createCommentVNode as c, createSlots as Be, withCtx as p, renderSlot as S, normalizeProps as H, guardReactiveProps as B, createVNode as q, createElementVNode as f, Fragment as I, renderList as m, toDisplayString as k, mergeProps as We, withDirectives as Ee, vModelCheckbox as Ye, createTextVNode as qe } from "vue";
import { _ as Xe } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Ue = J(), Ze = {
  name: "vue-ui-xy",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  components: {
    DataTable: we,
    Shape: Me,
    Title: Oe,
    Tooltip: Ge,
    UserOptions: ze,
    BaseIcon: pe,
    TableSparkline: Ve,
    Skeleton: Te,
    Slicer: Pe,
    Accordion: Re,
    PackageVersion: De,
    PenAndPaper: He
  },
  data() {
    this.dataset.forEach((u, t) => {
      [null, void 0].includes(u.series) && this.error({
        componentName: "VueUiXy",
        type: "datasetSerieAttribute",
        property: "series (number[])",
        index: t
      });
    });
    const a = this.config.downsample && this.config.downsample.threshold ? this.config.downsample.threshold : 500, s = Math.max(...this.dataset.map((u) => this.largestTriangleThreeBucketsArray({ data: u.series, threshold: a }).length)), o = {
      start: 0,
      end: s
    };
    return {
      themePalettes: K,
      themes: Q,
      slicerStep: 0,
      selectedScale: null,
      CTX: null,
      CANVAS: null,
      opacity: j,
      useSafeValues: !0,
      palette: $,
      height: 600,
      width: 1e3,
      viewBox: "0 0 1000 600",
      clientPosition: {
        x: 0,
        y: 0
      },
      canvasClientPosition: {
        x: 0,
        y: 0
      },
      icons: {
        line: "line",
        bar: "bar",
        plot: "plot"
      },
      isAnnotator: !1,
      isFullscreen: !1,
      isPrinting: !1,
      isImaging: !1,
      isTooltip: !1,
      mutableConfig: {
        dataLabels: {
          show: !0
        },
        showTooltip: !0,
        showTable: !1,
        isStacked: !1,
        useIndividualScale: !1
      },
      selectedSerieIndex: null,
      selectedRowIndex: null,
      segregatedSeries: [],
      uniqueId: J(),
      step: 0,
      tableStep: 0,
      titleStep: 0,
      slicer: o,
      __to__: null,
      maxX: s,
      showSparklineTable: !0,
      segregateStep: 0,
      sliderId: Ue,
      fontSizes: {
        xAxis: 18,
        yAxis: 12,
        dataLabels: 20,
        plotLabels: 10
      },
      plotRadii: {
        plot: 3,
        line: 3
      },
      selectedMinimapIndex: null,
      showUserOptionsOnChartHover: !1,
      keepUserOptionState: !0,
      userOptionsVisible: !0
    };
  },
  watch: {
    dataset: {
      handler(a, s) {
        this.maxX = Math.max(...this.dataset.map((o) => this.largestTriangleThreeBucketsArray({
          data: o.series,
          threshold: this.FINAL_CONFIG.downsample.threshold
        }).length)), this.slicer = {
          start: 0,
          end: this.maxX
        }, this.slicerStep += 1, this.segregateStep += 1;
      },
      deep: !0
    },
    config: {
      handler(a, s) {
        this.FINAL_CONFIG = this.prepareConfig(), this.prepareChart(), this.titleStep += 1, this.tableStep += 1;
      },
      deep: !0
    }
  },
  computed: {
    hasOptionsNoTitle() {
      return this.FINAL_CONFIG.chart.userOptions.show && (!this.FINAL_CONFIG.chart.title.show || !this.FINAL_CONFIG.chart.title.text);
    },
    minimap() {
      if (!this.FINAL_CONFIG.chart.zoom.minimap.show) return [];
      const a = this.datasetWithIds.filter((t) => !this.segregatedSeries.includes(t.id)), s = Math.max(...a.map((t) => t.series.length)), o = [];
      for (let t = 0; t < s; t += 1)
        o.push(a.map((e) => e.series[t] || 0).reduce((e, x) => (e || 0) + (x || 0), 0));
      const u = Math.min(...o);
      return o.map((t) => t + (u < 0 ? Math.abs(u) : 0));
    },
    customPalette() {
      return this.convertCustomPalette(this.FINAL_CONFIG.customPalette);
    },
    backgroundColor() {
      return this.FINAL_CONFIG.chart.backgroundColor;
    },
    slicerColor() {
      return this.FINAL_CONFIG.chart.zoom.color;
    },
    allScales() {
      const a = this.lineSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height,
        autoScaleYLabels: t.autoScaleYLabels
      })), s = this.barSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height
      })), o = this.plotSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        // FIX
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height
      })), u = [...a, ...s, ...o].flatMap((t) => t).length;
      return [...a, ...s, ...o].flatMap((t, e) => ({
        id: t.id,
        scaleLabel: t.scaleLabel,
        name: t.name,
        color: t.color,
        scale: t.scale,
        yOffset: t.yOffset,
        individualHeight: t.individualHeight,
        x: this.mutableConfig.isStacked ? this.drawingArea.left : this.drawingArea.left / u * (e + 1),
        yLabels: t.scaleYLabels || t.scale.ticks.map((x) => ({
          y: x >= 0 ? t.zero - t.individualHeight * (x / t.max) : t.zero + t.individualHeight * Math.abs(x) / t.max,
          value: x
        }))
      }));
    },
    isDataset() {
      return !!this.dataset && this.dataset.length;
    },
    chartFont() {
      const a = document.getElementById(`vue-ui-xy_${this.uniqueId}`);
      return window.getComputedStyle(a, null).getPropertyValue("font-family");
    },
    FINAL_CONFIG: {
      get: function() {
        return this.prepareConfig();
      },
      set: function(a) {
        return a;
      }
    },
    hasHighlightArea() {
      return Array.isArray(this.FINAL_CONFIG.chart.highlightArea) ? this.FINAL_CONFIG.chart.highlightArea.some((a) => a.show) : this.FINAL_CONFIG.chart.highlightArea && this.FINAL_CONFIG.chart.highlightArea.show;
    },
    highlightAreas() {
      if (Array.isArray(this.FINAL_CONFIG.chart.highlightArea))
        return this.FINAL_CONFIG.chart.highlightArea.map((s) => ({
          ...s,
          span: s.from === s.to ? 1 : s.to < s.from ? 0 : s.to - s.from + 1
        }));
      const a = this.FINAL_CONFIG.chart.highlightArea;
      return [{ ...a, span: a.from === a.to ? 1 : a.to < a.from ? 0 : a.to - a.from + 1 }];
    },
    xPadding() {
      return this.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : this.drawingArea.width / this.maxSeries / 2;
    },
    relativeZero() {
      return [null, void 0].includes(this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin) ? this.niceScale.min >= 0 ? 0 : Math.abs(this.niceScale.min) : -this.niceScale.min;
    },
    absoluteMax() {
      return this.niceScale.max + this.relativeZero;
    },
    datasetWithIds() {
      return this.useSafeValues ? this.dataset.map((a, s) => ({
        ...a,
        series: this.largestTriangleThreeBucketsArray({
          data: a.series,
          threshold: this.FINAL_CONFIG.downsample.threshold
        }),
        id: `uniqueId_${s}`
      })) : this.dataset;
    },
    safeDataset() {
      return this.useSafeValues ? this.dataset.map((a, s) => {
        const o = this.largestTriangleThreeBucketsArray({
          data: a.series,
          threshold: this.FINAL_CONFIG.downsample.threshold
        });
        return {
          ...a,
          slotAbsoluteIndex: s,
          series: o.map((u) => this.isSafeValue(u) ? u : null).slice(this.slicer.start, this.slicer.end),
          color: this.convertColorToHex(a.color ? a.color : this.customPalette[s] ? this.customPalette[s] : this.palette[s]),
          id: `uniqueId_${s}`
        };
      }) : this.dataset;
    },
    relativeDataset() {
      return this.safeDataset.map((a, s) => ({
        ...a,
        series: a.series.map((o) => o + this.relativeZero),
        absoluteValues: a.series
      })).filter((a) => !this.segregatedSeries.includes(a.id));
    },
    tableSparklineDataset() {
      return this.relativeDataset.map((a) => {
        const s = a.absoluteValues.map((o) => [void 0, null].includes(o) ? 0 : o);
        return {
          id: a.id,
          name: a.name,
          color: a.color,
          values: this.fillArray(this.maxSeries, s)
        };
      });
    },
    tableSparklineConfig() {
      return {
        responsiveBreakpoint: this.FINAL_CONFIG.table.responsiveBreakpoint,
        roundingValues: this.FINAL_CONFIG.table.rounding,
        showAverage: !1,
        showMedian: !1,
        showTotal: !1,
        fontFamily: this.FINAL_CONFIG.chart.fontFamily,
        prefix: this.FINAL_CONFIG.chart.labels.prefix,
        suffix: this.FINAL_CONFIG.chart.labels.suffix,
        colNames: JSON.parse(JSON.stringify(this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values)),
        thead: {
          backgroundColor: this.FINAL_CONFIG.table.th.backgroundColor,
          color: this.FINAL_CONFIG.table.th.color,
          outline: this.FINAL_CONFIG.table.th.outline
        },
        tbody: {
          backgroundColor: this.FINAL_CONFIG.table.td.backgroundColor,
          color: this.FINAL_CONFIG.table.td.color,
          outline: this.FINAL_CONFIG.table.td.outline
        },
        userOptions: {
          show: !1
        }
      };
    },
    absoluteDataset() {
      return this.safeDataset.map((a, s) => ({
        absoluteIndex: s,
        ...a,
        series: a.series.map((o) => o + this.relativeZero),
        absoluteValues: a.series,
        segregate: () => this.segregate(a),
        isSegregated: this.segregatedSeries.includes(a.id)
      }));
    },
    barSet() {
      return this.activeSeriesWithStackRatios.filter((a) => a.type === "bar").map((a, s) => {
        this.checkAutoScaleError(a);
        const o = Math.min(...a.absoluteValues.filter((g) => ![null, void 0].includes(g))), u = Math.max(...a.absoluteValues.filter((g) => ![null, void 0].includes(g))), e = {
          ratios: a.absoluteValues.filter((g) => ![null, void 0].includes(g)).map((g) => (g - o) / (u - o)),
          valueMin: o,
          valueMax: u < 0 ? 0 : u
        }, x = {
          max: a.scaleMax || Math.max(...a.absoluteValues) || 1,
          min: a.scaleMin || Math.min(...a.absoluteValues.filter((g) => ![void 0, null].includes(g))) > 0 ? 0 : Math.min(...a.absoluteValues.filter((g) => ![null, void 0].includes(g)))
        }, A = a.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, w = 1.0000001, N = this.calculateNiceScaleWithExactExtremes(x.min, x.max === x.min ? x.max * w : x.max, A), b = this.calculateNiceScaleWithExactExtremes(e.valueMin, e.valueMax === e.valueMin ? e.valueMax * w : e.valueMax, A), V = N.min >= 0 ? 0 : Math.abs(N.min), v = 0, z = N.max + V, O = b.max + Math.abs(v), _ = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - a.cumulatedStackRatio) : 0, C = this.mutableConfig.isStacked ? this.drawingArea.height * a.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, M = this.drawingArea.bottom - _ - C * V / z, r = this.drawingArea.bottom - _ - C * v / O, h = this.absoluteDataset.filter((g) => g.type === "bar").filter((g) => !this.segregatedSeries.includes(g.id)).length, n = a.series.map((g, F) => {
          const E = this.mutableConfig.useIndividualScale ? (a.absoluteValues[F] + V) / z : this.ratioToMax(g), Y = this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.drawingArea.left + this.drawingArea.width / this.maxSeries * F : this.drawingArea.left + this.slot.bar * s + this.slot.bar * F * h - this.barSlot / 2 - s * this.barPeriodGap;
          return {
            yOffset: this.checkNaN(_),
            individualHeight: this.checkNaN(C),
            x: this.checkNaN(Y),
            y: this.drawingArea.bottom - _ - C * E,
            value: a.absoluteValues[F],
            zeroPosition: this.checkNaN(M),
            individualMax: this.checkNaN(z),
            comment: a.comments && a.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
          };
        }), d = a.absoluteValues.map((g) => b.min >= 0 ? (g - Math.abs(b.min)) / (b.max - Math.abs(b.min)) : (g + Math.abs(b.min)) / (b.max + Math.abs(b.min))), W = a.series.map((g, F) => {
          const E = this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.drawingArea.left + this.drawingArea.width / this.maxSeries * F : this.drawingArea.left - this.slot.bar / 2 + this.slot.bar * s + this.slot.bar * F * this.absoluteDataset.filter((Y) => Y.type === "bar").filter((Y) => !this.segregatedSeries.includes(Y.id)).length;
          return {
            yOffset: this.checkNaN(_),
            individualHeight: this.checkNaN(C),
            x: this.checkNaN(E),
            y: this.checkNaN(this.drawingArea.bottom - this.checkNaN(_) - (this.checkNaN(C) * d[F] || 0)),
            value: a.absoluteValues[F],
            zeroPosition: this.checkNaN(M),
            individualMax: this.checkNaN(z),
            comment: a.comments && a.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
          };
        }), y = N.ticks.map((g) => ({
          y: g >= 0 ? M - C * (g / z) : M + C * Math.abs(g) / z,
          value: g,
          prefix: a.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: a.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: a
        })), G = b.ticks.map((g) => {
          const F = (g - b.min) / (b.max - b.min);
          return {
            y: g >= 0 ? r - C * F : r + C * F,
            value: g,
            prefix: a.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: a.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: a
          };
        });
        return {
          ...a,
          yOffset: _,
          autoScaleYLabels: G,
          individualHeight: C,
          scaleYLabels: a.autoScaling ? G : y,
          individualScale: a.autoScaling ? b : N,
          individualMax: a.autoScaling ? O : z,
          zeroPosition: a.autoScaling ? r : M,
          plots: a.autoScaling ? W : n
        };
      });
    },
    activeSeriesLength() {
      return this.absoluteDataset.length;
    },
    activeSeriesWithStackRatios() {
      return this.assignStackRatios(this.absoluteDataset.filter((a) => !this.segregatedSeries.includes(a.id)));
    },
    lineSet() {
      return this.activeSeriesWithStackRatios.filter((a) => a.type === "line").map((a) => {
        this.checkAutoScaleError(a);
        const s = Math.min(...a.absoluteValues.filter((g) => ![void 0, null].includes(g))), o = Math.max(...a.absoluteValues.filter((g) => ![void 0, null].includes(g))) || 1, t = {
          ratios: a.absoluteValues.filter((g) => ![null, void 0].includes(g)).map((g) => (g - s) / (o - s)),
          valueMin: s,
          valueMax: o
        }, e = {
          max: a.scaleMax || Math.max(...a.absoluteValues) || 1,
          min: a.scaleMin || (Math.min(...a.absoluteValues) > 0 ? 0 : Math.min(...a.absoluteValues))
        }, x = a.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, A = 1.0000001, w = this.calculateNiceScaleWithExactExtremes(e.min, e.max === e.min ? e.max * A : e.max, x), N = this.calculateNiceScaleWithExactExtremes(t.valueMin, t.valueMax === t.valueMin ? t.valueMax * A : t.valueMax, x), b = w.min >= 0 ? 0 : Math.abs(w.min), V = 0, v = w.max + Math.abs(b), z = N.max + Math.abs(V), O = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - a.cumulatedStackRatio) : 0, _ = this.mutableConfig.isStacked ? this.drawingArea.height * a.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, C = this.drawingArea.bottom - O - _ * b / v, M = this.drawingArea.bottom - O - _ * V / z, r = a.series.map((g, F) => {
          const E = this.mutableConfig.useIndividualScale ? (a.absoluteValues[F] + Math.abs(b)) / v : this.ratioToMax(g);
          return {
            x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * F),
            y: this.checkNaN(this.drawingArea.bottom - O - _ * E),
            value: a.absoluteValues[F],
            comment: a.comments && a.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
          };
        }), h = a.absoluteValues.map((g) => N.min >= 0 ? (g - Math.abs(N.min)) / (N.max - Math.abs(N.min)) : (g + Math.abs(N.min)) / (N.max + Math.abs(N.min))), n = a.series.map((g, F) => [void 0, null].includes(a.absoluteValues[F]) ? {
          x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * F),
          y: C,
          value: a.absoluteValues[F],
          comment: a.comments && a.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
        } : {
          x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * F),
          y: this.checkNaN(this.drawingArea.bottom - O - (_ * h[F] || 0)),
          value: a.absoluteValues[F],
          comment: a.comments && a.comments.slice(this.slicer.start, this.slicer.end)[F] || ""
        }), d = this.createSmoothPath(r), W = this.createSmoothPath(n), y = w.ticks.map((g) => ({
          y: g >= 0 ? C - _ * (g / v) : C + _ * Math.abs(g) / v,
          value: g,
          prefix: a.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: a.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: a
        })), G = N.ticks.map((g) => {
          const F = (g - N.min) / (N.max - N.min);
          return {
            y: g >= 0 ? M - _ * F : M + _ * F,
            value: g,
            prefix: a.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: a.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: a
          };
        });
        return {
          ...a,
          yOffset: O,
          autoScaleYLabels: G,
          individualHeight: _,
          scaleYLabels: a.autoScaling ? G : y,
          individualScale: a.autoScaling ? N : w,
          individualMax: a.autoScaling ? z : v,
          zeroPosition: a.autoScaling ? M : C,
          curve: a.autoScaling ? W : d,
          plots: a.autoScaling ? n : r,
          area: a.useArea ? this.mutableConfig.useIndividualScale ? this.createIndividualArea(a.autoScaling ? n : r, a.autoScaling ? M : C) : this.createArea(r) : ""
        };
      });
    },
    plotSet() {
      return this.activeSeriesWithStackRatios.filter((a) => a.type === "plot").map((a) => {
        this.checkAutoScaleError(a);
        const s = Math.min(...a.absoluteValues.filter((y) => ![null, void 0].includes(y))), o = Math.max(...a.absoluteValues.filter((y) => ![null, void 0].includes(y))) || 1, t = {
          ratios: a.absoluteValues.filter((y) => ![null, void 0].includes(y)).map((y) => (y - s) / (o - s)),
          valueMin: s,
          valueMax: o
        }, e = {
          max: a.scaleMax || Math.max(...a.absoluteValues) || 1,
          min: a.scaleMin || Math.min(...a.absoluteValues) > 0 ? 0 : Math.min(...a.absoluteValues)
        }, x = a.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, A = 1.0000001, w = this.calculateNiceScaleWithExactExtremes(e.min, e.max === e.min ? e.max * A : e.max, x), N = this.calculateNiceScaleWithExactExtremes(t.valueMin, t.valueMax === t.valueMin ? t.valueMax * A : t.valueMax, x), b = w.min >= 0 ? 0 : Math.abs(w.min), V = 0, v = w.max + b, z = N.max + Math.abs(V), O = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - a.cumulatedStackRatio) : 0, _ = this.mutableConfig.isStacked ? this.drawingArea.height * a.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, C = this.drawingArea.bottom - O - _ * b / v, M = this.drawingArea.bottom - O - _ * V / z, r = a.series.map((y, G) => {
          const g = this.mutableConfig.useIndividualScale ? (a.absoluteValues[G] + Math.abs(b)) / v : this.ratioToMax(y);
          return {
            x: this.checkNaN(this.drawingArea.left + this.slot.plot / 2 + this.slot.plot * G),
            y: this.checkNaN(this.drawingArea.bottom - O - _ * g),
            value: a.absoluteValues[G],
            comment: a.comments && a.comments.slice(this.slicer.start, this.slicer.end)[G] || ""
          };
        }), h = a.absoluteValues.map((y) => N.min >= 0 ? (y - Math.abs(N.min)) / (N.max - Math.abs(N.min)) : (y + Math.abs(N.min)) / (N.max + Math.abs(N.min))), n = a.series.map((y, G) => ({
          x: this.checkNaN(this.drawingArea.left + this.slot.plot / 2 + this.slot.plot * G),
          y: this.checkNaN(this.drawingArea.bottom - O - (_ * h[G] || 0)),
          value: a.absoluteValues[G],
          comment: a.comments && a.comments.slice(this.slicer.start, this.slicer.end)[G] || ""
        })), d = w.ticks.map((y) => ({
          y: y >= 0 ? C - _ * (y / v) : C + _ * Math.abs(y) / v,
          value: y,
          prefix: a.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: a.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: a
        })), W = N.ticks.map((y) => {
          const G = (y - N.min) / (N.max - N.min);
          return {
            y: y >= 0 ? M - _ * G : M + _ * G,
            value: y,
            prefix: a.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: a.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: a
          };
        });
        return {
          ...a,
          yOffset: O,
          autoScaleYLabels: W,
          individualHeight: _,
          scaleYLabels: a.autoScaling ? W : d,
          individualScale: a.autoScaling ? N : w,
          individualMax: a.autoScaling ? z : v,
          zeroPosition: a.autoScaling ? M : C,
          plots: a.autoScaling ? n : r
        };
      });
    },
    drawingArea() {
      const a = this.mutableConfig.useIndividualScale && this.FINAL_CONFIG.chart.grid.labels.show ? this.absoluteDataset.filter((s) => !this.segregatedSeries.includes(s.id)).length * (this.mutableConfig.isStacked ? 0 : this.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth) : 0;
      return {
        top: this.FINAL_CONFIG.chart.padding.top,
        right: this.width - this.FINAL_CONFIG.chart.padding.right,
        bottom: this.height - this.FINAL_CONFIG.chart.padding.bottom,
        left: this.FINAL_CONFIG.chart.padding.left + a,
        height: this.height - (this.FINAL_CONFIG.chart.padding.top + this.FINAL_CONFIG.chart.padding.bottom),
        width: this.width - (this.FINAL_CONFIG.chart.padding.right + this.FINAL_CONFIG.chart.padding.left + a)
      };
    },
    max() {
      return this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMax ? this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMax : Math.max(...this.safeDataset.filter((a) => !this.segregatedSeries.includes(a.id)).map((a) => Math.max(...a.series)));
    },
    min() {
      if (this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin !== null)
        return this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin;
      const a = Math.min(...this.safeDataset.filter((s) => !this.segregatedSeries.includes(s.id)).map((s) => Math.min(...s.series)));
      return a > 0 ? 0 : a;
    },
    niceScale() {
      return this.calculateNiceScaleWithExactExtremes(this.min, this.max < 0 ? 0 : this.max, this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps);
    },
    maxSeries() {
      return this.slicer.end - this.slicer.start;
    },
    timeLabels() {
      const a = Math.max(...this.dataset.map((o) => this.largestTriangleThreeBucketsArray({ data: o.series, threshold: this.FINAL_CONFIG.downsample.threshold }).length)), s = [];
      for (let o = 0; o < a; o += 1)
        s.push({
          text: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[o] || String(o),
          absoluteIndex: o
        });
      return s.slice(this.slicer.start, this.slicer.end);
    },
    slot() {
      return {
        bar: this.drawingArea.width / this.maxSeries / this.safeDataset.filter((a) => a.type === "bar").filter((a) => !this.segregatedSeries.includes(a.id)).length,
        plot: this.drawingArea.width / this.maxSeries,
        line: this.drawingArea.width / this.maxSeries
      };
    },
    barSlot() {
      const a = this.safeDataset.filter((s) => s.type === "bar").filter((s) => !this.segregatedSeries.includes(s.id)).length;
      return this.drawingArea.width / this.maxSeries / a - this.barPeriodGap * a;
    },
    barPeriodGap() {
      return this.slot.line * this.FINAL_CONFIG.bar.periodGap;
    },
    maxSlot() {
      return Math.max(...Object.values(this.slot).filter((a) => a !== 1 / 0));
    },
    table() {
      if (this.safeDataset.length === 0) return { head: [], body: [], config: {}, columnNames: [] };
      const a = this.relativeDataset.map((o) => ({
        label: o.name,
        color: o.color,
        type: o.type
      })), s = [];
      return this.timeLabels.forEach((o, u) => {
        const t = [o.text];
        this.relativeDataset.forEach((e) => {
          t.push(this.canShowValue(e.absoluteValues[u]) ? Number(e.absoluteValues[u].toFixed(this.FINAL_CONFIG.table.rounding)) : "");
        }), s.push(t);
      }), { head: a, body: s };
    },
    dataTable() {
      const a = this.FINAL_CONFIG.table.showSum;
      let s = [""].concat(this.relativeDataset.map((e) => e.name));
      a && (s = s.concat(' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>'));
      let o = [];
      for (let e = 0; e < this.maxSeries; e += 1) {
        const x = this.relativeDataset.map((A) => A.absoluteValues[e] ?? 0).reduce((A, w) => A + w, 0);
        o.push(
          [
            this.timeLabels[e].text ?? "-"
          ].concat(this.relativeDataset.map(
            (A) => this.applyDataLabel(
              A.type === "line" ? this.FINAL_CONFIG.line.labels.formatter : A.type === "bar" ? this.FINAL_CONFIG.bar.labels.formatter : this.FINAL_CONFIG.plot.labels.formatter,
              A.absoluteValues[e] ?? 0,
              this.dataLabel({
                p: A.prefix || this.FINAL_CONFIG.chart.labels.prefix,
                v: A.absoluteValues[e] ?? 0,
                s: A.suffix || this.FINAL_CONFIG.chart.labels.suffix,
                r: this.FINAL_CONFIG.table.rounding
              })
            )
          )).concat(a ? (x ?? 0).toFixed(this.FINAL_CONFIG.table.rounding) : [])
        );
      }
      const u = {
        th: {
          backgroundColor: this.FINAL_CONFIG.table.th.backgroundColor,
          color: this.FINAL_CONFIG.table.th.color,
          outline: this.FINAL_CONFIG.table.th.outline
        },
        td: {
          backgroundColor: this.FINAL_CONFIG.table.td.backgroundColor,
          color: this.FINAL_CONFIG.table.td.color,
          outline: this.FINAL_CONFIG.table.td.outline
        },
        breakpoint: this.FINAL_CONFIG.table.responsiveBreakpoint
      }, t = [this.FINAL_CONFIG.table.columnNames.period].concat(this.relativeDataset.map((e) => e.name)).concat(this.FINAL_CONFIG.table.columnNames.total);
      return { head: s, body: o, config: u, colNames: t };
    },
    dataTooltipSlot() {
      return {
        datapoint: this.selectedSeries,
        seriesIndex: this.selectedSerieIndex,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      };
    },
    selectedSeries() {
      return this.relativeDataset.map((a) => ({
        slotAbsoluteIndex: a.slotAbsoluteIndex,
        shape: a.shape || null,
        name: a.name,
        color: a.color,
        type: a.type,
        value: a.absoluteValues.find((s, o) => o === this.selectedSerieIndex),
        comments: a.comments || [],
        prefix: a.prefix || this.FINAL_CONFIG.chart.labels.prefix,
        suffix: a.suffix || this.FINAL_CONFIG.chart.labels.suffix
      }));
    },
    tooltipContent() {
      let a = "", s = this.selectedSeries.map((t) => t.value).filter((t) => this.isSafeValue(t) && t !== null).reduce((t, e) => Math.abs(t) + Math.abs(e), 0);
      const o = this.timeLabels[this.selectedSerieIndex], u = this.FINAL_CONFIG.chart.tooltip.customFormat;
      return this.isFunction(u) && this.functionReturnsString(() => u({
        seriesIndex: this.selectedSerieIndex,
        datapoint: this.selectedSeries,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      })) ? u({
        seriesIndex: this.selectedSerieIndex,
        datapoint: this.selectedSeries,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      }) : (o && o.text && this.FINAL_CONFIG.chart.tooltip.showTimeLabel && (a += `<div style="padding-bottom: 6px; margin-bottom: 4px; border-bottom: 1px solid ${this.FINAL_CONFIG.chart.tooltip.borderColor}; width:100%">${o.text}</div>`), this.selectedSeries.forEach((t) => {
        if (this.isSafeValue(t.value)) {
          let e = "", x = "";
          switch (this.icons[t.type]) {
            case "bar":
              e = `<svg viewBox="0 0 40 40" height="14" width="14">${this.$slots.pattern ? `<rect x="0" y="0" rx="1" stroke="none" height="40" width="40" fill="${t.color}" />` : ""}<rect x="0" y="0" rx="1" stroke="none" height="40" width="40" fill="${this.$slots.pattern ? `url(#pattern_${this.uniqueId}_${t.slotAbsoluteIndex}` : t.color}" /></svg>`;
              break;
            case "line":
              !t.shape || !["star", "triangle", "square", "diamond", "pentagon", "hexagon"].includes(t.shape) ? x = `<circle cx="10" cy="8" r="4" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" fill="${t.color}" />` : t.shape === "triangle" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 3, rotation: 0.52 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "square" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 4, rotation: 0.8 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "diamond" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 4, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "pentagon" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 5, rotation: 0.95 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "hexagon" ? x = `<path d="${R({ plot: { x: 10, y: 8 }, radius: 4, sides: 6, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "star" && (x = `<polygon stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" fill="${t.color}" points="${X({ plot: { x: 10, y: 8 }, radius: 4 })}" />`), e = `<svg viewBox="0 0 20 12" height="14" width="20"><rect rx="1.5" x="0" y="6.5" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" height="3" width="20" fill="${t.color}" />${x}</svg>`;
              break;
            case "plot":
              if (!t.shape || !["star", "triangle", "square", "diamond", "pentagon", "hexagon"].includes(t.shape)) {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${t.color}" /></svg>`;
                break;
              }
              if (t.shape === "star") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><polygon stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${t.color}" points="${X({ plot: { x: 6, y: 6 }, radius: 5 })}" /></svg>`;
                break;
              }
              if (t.shape === "triangle") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 6, sides: 3, rotation: 0.52 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "square") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 6, sides: 4, rotation: 0.8 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "diamond") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 5, sides: 4, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "pentagon") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 5, sides: 5, rotation: 0.95 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "hexagon") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${R({ plot: { x: 6, y: 6 }, radius: 5, sides: 6, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
          }
          a += `<div style="display:flex;flex-direction:row; align-items:center;gap:3px;"><div style="width:20px">${e}</div> ${t.name}: <b>${this.FINAL_CONFIG.chart.tooltip.showValue ? this.applyDataLabel(
            t.type === "line" ? this.FINAL_CONFIG.line.labels.formatter : t.type === "bar" ? this.FINAL_CONFIG.bar.labels.formatter : this.FINAL_CONFIG.plot.labels.formatter,
            t.value,
            this.dataLabel({
              p: t.prefix,
              v: t.value,
              s: t.suffix,
              r: this.FINAL_CONFIG.chart.tooltip.roundingValue
            }),
            { datapoint: t }
          ) : ""}</b> ${this.FINAL_CONFIG.chart.tooltip.showPercentage ? `(${U({
            v: this.checkNaN(Math.abs(t.value) / s * 100),
            s: "%",
            r: this.FINAL_CONFIG.chart.tooltip.roundingPercentage
          })})` : ""}</div>`, this.FINAL_CONFIG.chart.comments.showInTooltip && t.comments.length && t.comments.slice(this.slicer.start, this.slicer.end)[this.selectedSerieIndex] && (a += `<div class="vue-data-ui-tooltip-comment" style="background:${t.color}20; padding: 6px; margin-bottom: 6px; border-left: 1px solid ${t.color}">${t.comments.slice(this.slicer.start, this.slicer.end)[this.selectedSerieIndex]}</div>`);
        }
      }), `<div style="border-radius:4px;padding:12px;font-variant-numeric: tabular-nums;color:${this.FINAL_CONFIG.chart.tooltip.color}">${a}</div>`);
    },
    svg() {
      return {
        height: this.height,
        width: this.width
      };
    },
    yLabels() {
      return this.niceScale.ticks.map((a) => ({
        y: a >= 0 ? this.zero - this.drawingArea.height * this.ratioToMax(a) : this.zero + this.drawingArea.height * this.ratioToMax(Math.abs(a)),
        value: a,
        prefix: this.FINAL_CONFIG.chart.labels.prefix,
        suffix: this.FINAL_CONFIG.chart.labels.suffix
      }));
    },
    zero() {
      return this.drawingArea.bottom - this.drawingArea.height * this.ratioToMax(this.relativeZero);
    }
  },
  mounted() {
    this.prepareChart(), this.setupSlicer(), document.addEventListener("mousemove", (a) => {
      this.clientPosition = {
        x: a.clientX,
        y: a.clientY
      };
    });
  },
  methods: {
    abbreviate: ee,
    adaptColorToBackground: te,
    applyDataLabel: ae,
    assignStackRatios: re,
    calcLinearProgression: le,
    calculateNiceScaleWithExactExtremes: ie,
    checkNaN: se,
    closestDecimal: ne,
    convertColorToHex: he,
    convertConfigColors: oe,
    convertCustomPalette: ce,
    createCsvContent: de,
    createSmoothPath: ue,
    createTSpans: ge,
    dataLabel: U,
    downloadCsv: fe,
    error: Ie,
    forceValidValue: me,
    functionReturnsString: Ne,
    hasDeepProperty: xe,
    isFunction: be,
    isSafeValue: Fe,
    largestTriangleThreeBucketsArray: _e,
    objectIsEmpty: Ae,
    setOpacity: ye,
    shiftHue: Le,
    translateSize: Ce,
    treeShake: Se,
    useMouse: ve,
    useNestedProp: Z,
    setUserOptionsVisibility(a = !1) {
      this.showUserOptionsOnChartHover && (this.userOptionsVisible = a);
    },
    toggleAnnotator() {
      this.isAnnotator = !this.isAnnotator;
    },
    selectTimeLabel(a, s) {
      const o = this.relativeDataset.map((u) => ({
        shape: u.shape || null,
        name: u.name,
        color: u.color,
        type: u.type,
        value: u.absoluteValues.find((t, e) => e === s),
        comments: u.comments || [],
        prefix: u.prefix || this.FINAL_CONFIG.chart.labels.prefix,
        suffix: u.suffix || this.FINAL_CONFIG.chart.labels.suffix
      }));
      this.$emit("selectTimeLabel", {
        datapoint: o,
        absoluteIndex: a.absoluteIndex,
        label: a.text
      });
    },
    getHighlightAreaPosition(a) {
      const s = this.drawingArea.left + this.drawingArea.width / this.maxSeries * (a.from - this.slicer.start), o = this.drawingArea.width / (this.slicer.end - this.slicer.start) * a.span < 0 ? 1e-5 : this.drawingArea.width / (this.slicer.end - this.slicer.start) * a.span;
      return {
        x: s < this.drawingArea.left ? this.drawingArea.left : s,
        width: o
      };
    },
    prepareConfig() {
      const a = ke().vue_ui_xy;
      if (!Object.keys(this.config || {}).length)
        return a;
      const s = this.useNestedProp({
        userConfig: this.config,
        defaultConfig: a
      });
      return this.config && this.hasDeepProperty(this.config, "chart.highlightArea") && (Array.isArray(this.config.chart.highlightArea) ? s.chart.highlightArea = this.config.chart.highlightArea : s.chart.highlightArea = [this.config.chart.highlightArea]), this.config && this.hasDeepProperty(this.config, "chart.grid.labels.yAxis.scaleMin") ? s.chart.grid.labels.yAxis.scaleMin = this.config.chart.grid.labels.yAxis.scaleMin : s.chart.grid.labels.yAxis.scaleMin = null, this.config && this.hasDeepProperty(this.config, "chart.grid.labels.yAxis.scaleMax") ? s.chart.grid.labels.yAxis.scaleMax = this.config.chart.grid.labels.yAxis.scaleMax : s.chart.grid.labels.yAxis.scaleMax = null, this.config && this.hasDeepProperty(this.config, "chart.zoom.startIndex") ? s.chart.zoom.startIndex = this.config.chart.zoom.startIndex : s.chart.zoom.startIndex = null, this.config && this.hasDeepProperty(this.config, "chart.zoom.endIndex") ? s.chart.zoom.endIndex = this.config.chart.zoom.endIndex : s.chart.zoom.endIndex = null, s.theme ? {
        ...Z({
          userConfig: this.themes.vue_ui_xy[s.theme] || this.config,
          defaultConfig: s
        }),
        customPalette: this.themePalettes[s.theme] || this.palette
      } : s;
    },
    prepareChart() {
      if (this.objectIsEmpty(this.dataset) ? this.error({
        componentName: "VueUiXy",
        type: "dataset"
      }) : this.dataset.forEach((a, s) => {
        [null, void 0].includes(a.name) && this.error({
          componentName: "VueUiXy",
          type: "datasetSerieAttribute",
          property: "name (string)",
          index: s
        });
      }), this.FINAL_CONFIG.showWarnings && this.dataset.forEach((a) => {
        a.series.forEach((s, o) => {
          this.isSafeValue(s) || console.warn(`VueUiXy has detected an unsafe value in your dataset:
-----> The serie '${a.name}' contains the value '${s}' at index ${o}.
'${s}' was converted to null to allow the chart to display.`);
        });
      }), this.showUserOptionsOnChartHover = this.FINAL_CONFIG.chart.userOptions.showOnChartHover, this.keepUserOptionState = this.FINAL_CONFIG.chart.userOptions.keepStateOnChartLeave, this.userOptionsVisible = !this.FINAL_CONFIG.chart.userOptions.showOnChartHover, this.mutableConfig = {
        dataLabels: {
          show: !0
        },
        showTooltip: this.FINAL_CONFIG.chart.tooltip.show === !0,
        showTable: this.FINAL_CONFIG.showTable === !0,
        isStacked: this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked,
        useIndividualScale: this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale
      }, this.FINAL_CONFIG.responsive) {
        const s = this.$refs.chart.parentNode, { height: o, width: u } = s.getBoundingClientRect();
        let t = null, e = 0;
        this.FINAL_CONFIG.chart.title.show && (t = this.$refs.chartTitle, e = t.getBoundingClientRect().height);
        let x = null, A = 0;
        this.FINAL_CONFIG.chart.zoom.show && this.maxX > 6 && this.isDataset && (x = this.$refs.chartSlicer.$el, A = x.getBoundingClientRect().height);
        let w = null, N = 0;
        this.FINAL_CONFIG.chart.legend.show && (w = this.$refs.chartLegend, N = w.getBoundingClientRect().height);
        let b = 0;
        this.$refs.source && (b = this.$refs.source.getBoundingClientRect().height);
        let V = 0;
        this.$refs.noTitle && (V = this.$refs.noTitle.getBoundingClientRect().height), this.height = o - e - N - A - b - V, this.width = u, this.viewBox = `0 0 ${this.width < 0 ? 10 : this.width} ${this.height < 0 ? 10 : this.height}`, this.convertSizes(), new ResizeObserver((z) => {
          for (const O of z)
            this.$refs.chartTitle && (e = this.$refs.chartTitle.getBoundingClientRect().height), this.$refs.chartSlicer && this.$refs.chartSlicer.$el && (A = this.$refs.chartSlicer.$el.getBoundingClientRect().height), this.$refs.chartLegend && (N = this.$refs.chartLegend.getBoundingClientRect().height), this.$refs.source && (b = this.$refs.source.getBoundingClientRect().height), this.height = O.contentBoxSize[0].blockSize - e - N - A - b - 24, this.width = O.contentBoxSize[0].inlineSize, this.viewBox = `0 0 ${this.width < 0 ? 10 : this.width} ${this.height < 0 ? 10 : this.height}`, this.convertSizes();
        }).observe(s);
      } else
        this.height = this.FINAL_CONFIG.chart.height, this.width = this.FINAL_CONFIG.chart.width, this.viewBox = `0 0 ${this.width} ${this.height}`, this.fontSizes.dataLabels = this.FINAL_CONFIG.chart.grid.labels.fontSize, this.fontSizes.yAxis = this.FINAL_CONFIG.chart.grid.labels.axis.fontSize, this.fontSizes.xAxis = this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.fontSize, this.fontSizes.plotLabels = this.FINAL_CONFIG.chart.labels.fontSize, this.plotRadii.plot = this.FINAL_CONFIG.plot.radius, this.plotRadii.line = this.FINAL_CONFIG.line.radius;
    },
    selectMinimapIndex(a) {
      this.selectedMinimapIndex = a;
    },
    convertSizes() {
      this.fontSizes.dataLabels = this.translateSize({
        relator: this.height,
        adjuster: 400,
        source: this.FINAL_CONFIG.chart.grid.labels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.yAxis = this.translateSize({
        relator: this.width,
        adjuster: 1e3,
        source: this.FINAL_CONFIG.chart.grid.labels.axis.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.xAxis = this.translateSize({
        relator: this.width,
        adjuster: 1e3,
        source: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.plotLabels = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.chart.labels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.plotRadii.plot = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.plot.radius,
        threshold: 1,
        fallback: 1
      }), this.plotRadii.line = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.line.radius,
        threshold: 1,
        fallback: 1
      });
    },
    toggleStack() {
      this.mutableConfig.isStacked = !this.mutableConfig.isStacked, this.mutableConfig.isStacked ? this.mutableConfig.useIndividualScale = !0 : this.mutableConfig.useIndividualScale = this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale;
    },
    toggleTable() {
      this.mutableConfig.showTable = !this.mutableConfig.showTable;
    },
    toggleLabels() {
      this.mutableConfig.dataLabels.show = !this.mutableConfig.dataLabels.show;
    },
    toggleTooltip() {
      this.mutableConfig.showTooltip = !this.mutableConfig.showTooltip;
    },
    checkAutoScaleError(a) {
      a.autoScaling && (this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale || console.warn(`VueUiXy (datapoint: ${a.name}) : autoScaling only works when config.chart.grid.labels.yAxis.useIndividualScale is set to true`), this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked || console.warn(`VueUiXy (datapoint: ${a.name}) : autoScaling only works when config.chart.grid.labels.yAxis.stacked is set to true`));
    },
    createArea(a) {
      if (!a[0]) return [-10, -10, "", -10, -10];
      const s = { x: a[0].x, y: this.zero }, o = { x: a.at(-1).x, y: this.zero }, u = [];
      return a.forEach((t) => {
        u.push(`${t.x},${t.y} `);
      }), [s.x, s.y, ...u, o.x, o.y].toString();
    },
    createIndividualArea(a, s) {
      if (!a[0]) return [-10, -10, "", -10, -10];
      const o = { x: a[0] ? a[0].x : Math.min(...a.filter((e) => !!e).map((e) => e.x)), y: s }, u = { x: a.at(-1) ? a.at(-1).x : Math.min(...a.filter((e) => !!e).map((e) => e.x)), y: s }, t = [];
      return a.filter((e) => !!e).forEach((e) => {
        t.push(`${e.x},${e.y} `);
      }), [o.x, o.y, ...t, u.x, u.y].toString();
    },
    createStar: X,
    createPolygonPath: R,
    fillArray(a, s) {
      let o = Array(a).fill(0);
      for (let u = 0; u < s.length && u < a; u += 1)
        o[u] = s[u];
      return o;
    },
    async setupSlicer() {
      (this.FINAL_CONFIG.chart.zoom.startIndex !== null || this.FINAL_CONFIG.chart.zoom.endIndex !== null) && this.$refs.chartSlicer ? (this.FINAL_CONFIG.chart.zoom.startIndex !== null && (await this.$nextTick(), await this.$nextTick(), this.$refs.chartSlicer.setStartValue(this.FINAL_CONFIG.chart.zoom.startIndex)), this.FINAL_CONFIG.chart.zoom.endIndex !== null && (await this.$nextTick(), await this.$nextTick(), this.$refs.chartSlicer.setEndValue(this.validSlicerEnd(this.FINAL_CONFIG.chart.zoom.endIndex + 1)))) : (this.slicer = {
        start: 0,
        end: Math.max(...this.dataset.map((a) => this.largestTriangleThreeBucketsArray({ data: a.series, threshold: this.FINAL_CONFIG.downsample.threshold }).length))
      }, this.slicerStep += 1);
    },
    refreshSlicer() {
      this.setupSlicer();
    },
    validSlicerEnd(a) {
      const s = Math.max(...this.dataset.map((o) => this.largestTriangleThreeBucketsArray({ data: o.series, threshold: this.FINAL_CONFIG.downsample.threshold }).length));
      return a > s ? s : a < 0 || this.FINAL_CONFIG.chart.zoom.startIndex !== null && a < this.FINAL_CONFIG.chart.zoom.startIndex ? this.FINAL_CONFIG.chart.zoom.startIndex !== null ? this.FINAL_CONFIG.chart.zoom.startIndex + 1 : 1 : a;
    },
    calcRectHeight(a) {
      const s = ![null, void 0].includes(this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin) && this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin > 0 && this.min >= 0 ? this.drawingArea.bottom : this.zero;
      return a.value >= 0 ? this.checkNaN(s - a.y <= 0 ? 1e-5 : s - a.y) : this.checkNaN(a.y - this.zero <= 0 ? 1e-5 : a.y - this.zero);
    },
    calcIndividualHeight(a) {
      return a.value >= 0 ? this.checkNaN(a.zeroPosition - a.y <= 0 ? 1e-5 : a.zeroPosition - a.y) : this.checkNaN(a.y - a.zeroPosition <= 0 ? 1e-5 : a.zeroPosition - a.y);
    },
    calcRectWidth() {
      return this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.slot.line - this.drawingArea.width / this.maxSeries * 0.1 : this.slot.bar;
    },
    calcRectX(a) {
      return this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? a.x + this.drawingArea.width / this.maxSeries * 0.05 : a.x + this.slot.bar / 2;
    },
    calcRectY(a) {
      return a.value >= 0 ? a.y : this.zero;
    },
    calcIndividualRectY(a) {
      return a.value >= 0 ? a.y : [null, void 0, NaN, 1 / 0, -1 / 0].includes(a.zeroPosition) ? 0 : a.zeroPosition;
    },
    canShowValue(a) {
      return ![null, void 0, NaN, 1 / 0, -1 / 0].includes(a);
    },
    findClosestValue(a, s) {
      let o = s[0], u = Math.abs(a - s[0]);
      for (let t = 1; t < s.length; t += 1) {
        const e = Math.abs(a - s[t]);
        e < u && s[t] < a && (o = s[t], u = e);
      }
      return o;
    },
    ratioToMax(a) {
      return a / (this.canShowValue(this.absoluteMax) ? this.absoluteMax : 1);
    },
    selectX(a) {
      this.$emit(
        "selectX",
        {
          dataset: this.relativeDataset.map((s) => ({
            name: s.name,
            value: [null, void 0, NaN].includes(s.absoluteValues[a]) ? null : s.absoluteValues[a],
            color: s.color,
            type: s.type
          })),
          index: a,
          indexLabel: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[a]
        }
      );
    },
    getData() {
      return this.absoluteDataset.map((a) => ({
        values: a.absoluteValues,
        color: a.color,
        name: a.name,
        type: a.type
      }));
    },
    segregate(a) {
      if (this.segregatedSeries.includes(a.id))
        this.segregatedSeries = this.segregatedSeries.filter((s) => s !== a.id);
      else {
        if (this.segregatedSeries.length + 1 === this.safeDataset.length) return;
        this.segregatedSeries.push(a.id);
      }
      this.$emit("selectLegend", this.relativeDataset.map((s) => ({
        name: s.name,
        values: s.absoluteValues,
        color: s.color,
        type: s.type
      }))), this.segregateStep += 1;
    },
    toggleTooltipVisibility(a, s = null) {
      this.isTooltip = a, a ? this.selectedSerieIndex = s : this.selectedSerieIndex = null;
    },
    toggleFullscreen(a) {
      this.isFullscreen = a, this.step += 1;
    },
    showSpinnerPdf() {
      this.isPrinting = !0;
    },
    async generatePdf() {
      this.showSpinnerPdf(), clearTimeout(this.__to__), this.isPrinting = !0, this.__to__ = setTimeout(async () => {
        try {
          const { default: a } = await import("./pdf-B7oVat64.js");
          await a({
            domElement: document.getElementById(`vue-ui-xy_${this.uniqueId}`),
            fileName: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy"
          });
        } catch (a) {
          console.error("Error generating PDF:", a);
        } finally {
          this.isPrinting = !1;
        }
      }, 100);
    },
    generateCsv() {
      const a = [[this.FINAL_CONFIG.chart.title.text], [this.FINAL_CONFIG.chart.title.subtitle.text], [""]], s = ["", ...this.table.head.map((e) => e.label)], o = this.table.body, u = a.concat([s]).concat(o), t = this.createCsvContent(u);
      this.downloadCsv({ csvContent: t, title: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy" });
    },
    showSpinnerImage() {
      this.isImaging = !0;
    },
    async generateImage() {
      this.showSpinnerImage(), clearTimeout(this.__to__), this.isImaging = !0, this.__to__ = setTimeout(async () => {
        try {
          const { default: a } = await import("./img-DGzWcJ4Y.js");
          await a({
            domElement: document.getElementById(`vue-ui-xy_${this.uniqueId}`),
            fileName: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy",
            format: "png"
          });
        } catch (a) {
          console.error("Error generating image:", a);
        } finally {
          this.isImaging = !1;
        }
      }, 100);
    }
  }
}, Je = ["id"], Ke = {
  key: 1,
  ref: "noTitle",
  class: "vue-data-ui-no-title-space",
  style: "height:36px; width: 100%; background:transparent"
}, Qe = ["viewBox"], je = ["x", "y", "width", "height"], $e = { key: 1 }, et = { class: "vue-ui-xy-grid" }, tt = ["stroke", "x1", "x2", "y1", "y2"], at = ["stroke", "x1", "x2", "y1", "y2"], rt = { key: 1 }, lt = ["x1", "x2", "y1", "y2", "stroke"], it = ["x1", "x2", "y1", "y2", "stroke"], st = ["x1", "x2", "y1", "y2", "stroke"], nt = { key: 3 }, ht = ["x1", "x2", "y1", "y2", "stroke"], ot = ["id"], ct = ["stop-color"], dt = ["stop-color"], ut = ["stop-color"], gt = ["id"], ft = ["stop-color"], It = ["stop-color"], mt = ["stop-color"], Nt = ["id"], xt = ["stop-color"], bt = ["stop-color"], Ft = ["id"], _t = ["stop-color"], At = ["stop-color"], yt = ["id"], Lt = ["stop-color"], Ct = ["stop-color"], St = ["x", "y", "height", "width", "fill"], kt = ["x", "y", "width"], wt = ["x", "y", "height", "width", "fill"], Ot = ["x", "y", "height", "width", "rx", "fill", "stroke", "stroke-width"], Gt = ["x", "y", "height", "width", "rx", "fill", "stroke", "stroke-width"], vt = ["width", "x", "y"], zt = { key: 0 }, Mt = ["id"], pt = ["fill"], Vt = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], Tt = ["x", "y", "font-size", "fill"], Pt = ["stroke", "x1", "x2", "y1", "y2"], Rt = { key: 2 }, Dt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], Ht = ["x", "y", "width", "height", "stroke", "stroke-width", "stroke-linecap", "stroke-linejoin", "stroke-dasharray"], Bt = { key: 4 }, Wt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Et = ["fill", "font-size", "transform"], Yt = ["x1", "x2", "y1", "y2", "stroke"], qt = ["x", "y", "font-size", "fill"], Xt = ["x1", "x2", "y1", "y2", "stroke"], Ut = ["x", "y", "font-size", "fill"], Zt = ["width", "x", "y"], Jt = { style: { width: "100%" } }, Kt = { key: 0 }, Qt = ["id"], jt = ["fill"], $t = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], ea = ["x", "y", "font-size", "fill"], ta = ["d", "stroke", "stroke-width", "stroke-dasharray"], aa = { key: 1 }, ra = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], la = { key: 5 }, ia = { key: 0 }, sa = ["d", "fill"], na = ["d", "fill"], ha = ["d", "fill"], oa = ["d", "fill"], ca = ["d", "stroke", "stroke-width", "stroke-dasharray"], da = { key: 2 }, ua = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], ga = ["width", "x", "y"], fa = { style: { width: "100%" } }, Ia = { key: 3 }, ma = ["id"], Na = ["fill"], xa = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], ba = ["x", "y", "font-size", "fill"], Fa = { key: 6 }, _a = ["x", "y", "font-size", "fill"], Aa = ["x", "y", "font-size", "fill", "font-weight"], ya = { key: 7 }, La = ["x", "y", "font-size", "fill"], Ca = ["x", "y"], Sa = ["x", "y"], ka = { key: 8 }, wa = ["x", "y", "font-size", "fill"], Oa = ["x", "y"], Ga = ["x", "y"], va = ["x", "y", "font-size", "fill", "innerHTML"], za = ["x", "y", "font-size", "fill", "innerHTML"], Ma = ["x", "y", "font-size", "fill", "innerHTML"], pa = ["x", "y", "font-size", "fill", "innerHTML"], Va = ["x", "y", "width", "height", "fill", "onMouseenter"], Ta = ["font-size", "fill", "transform"], Pa = ["x", "y", "font-size", "fill"], Ra = { key: 10 }, Da = ["text-anchor", "font-size", "fill", "transform", "onClick"], Ha = ["x", "y", "height", "width", "onMouseenter", "onClick"], Ba = { key: 11 }, Wa = ["x", "y"], Ea = ["cx", "cy", "r", "fill"], Ya = {
  key: 5,
  class: "vue-data-ui-watermark"
}, qa = ["onClick"], Xa = {
  key: 0,
  viewBox: "0 0 20 12",
  height: "14",
  width: "20"
}, Ua = ["stroke", "fill"], Za = {
  key: 1,
  viewBox: "0 0 40 40",
  height: "14",
  width: "14"
}, Ja = ["fill"], Ka = ["fill"], Qa = {
  key: 2,
  viewBox: "0 0 12 12",
  height: "14",
  width: "14"
}, ja = {
  key: 9,
  ref: "chartLegend"
}, $a = {
  key: 10,
  ref: "source",
  dir: "auto"
}, er = {
  style: { display: "flex", "flex-direction": "row", gap: "6px", "align-items": "center", "padding-left": "6px" },
  "data-html2canvas-ignore": ""
}, tr = ["innerHTML"];
function ar(a, s, o, u, t, e) {
  const x = T("PenAndPaper"), A = T("Title"), w = T("UserOptions"), N = T("PackageVersion"), b = T("Shape"), V = T("Skeleton"), v = T("Slicer"), z = T("Tooltip"), O = T("BaseIcon"), _ = T("TableSparkline"), C = T("DataTable"), M = T("Accordion");
  return l(), i("div", {
    id: `vue-ui-xy_${t.uniqueId}`,
    class: P(`vue-ui-xy ${t.isFullscreen ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.FINAL_CONFIG.useCssAnimation ? "" : "vue-ui-dna"}`),
    ref: "chart",
    style: L(`background:${e.FINAL_CONFIG.chart.backgroundColor}; color:${e.FINAL_CONFIG.chart.color};width:100%;font-family:${e.FINAL_CONFIG.chart.fontFamily};${e.FINAL_CONFIG.responsive ? "height: 100%" : ""}`),
    onMouseenter: s[7] || (s[7] = () => e.setUserOptionsVisibility(!0)),
    onMouseleave: s[8] || (s[8] = () => e.setUserOptionsVisibility(!1))
  }, [
    e.FINAL_CONFIG.chart.userOptions.buttons.annotator ? (l(), D(x, {
      key: 0,
      parent: a.$refs.chart,
      backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
      color: e.FINAL_CONFIG.chart.color,
      active: t.isAnnotator,
      onClose: e.toggleAnnotator
    }, null, 8, ["parent", "backgroundColor", "color", "active", "onClose"])) : c("", !0),
    e.hasOptionsNoTitle ? (l(), i("div", Ke, null, 512)) : c("", !0),
    e.FINAL_CONFIG.chart.title.show ? (l(), i("div", {
      key: 2,
      ref: "chartTitle",
      class: "vue-ui-xy-title",
      style: L(`font-family:${e.FINAL_CONFIG.chart.fontFamily}`)
    }, [
      (l(), D(A, {
        key: `title_${t.titleStep}`,
        config: {
          title: {
            cy: "xy-div-title",
            ...e.FINAL_CONFIG.chart.title
          },
          subtitle: {
            cy: "xy-div-subtitle",
            ...e.FINAL_CONFIG.chart.title.subtitle
          }
        }
      }, null, 8, ["config"]))
    ], 4)) : c("", !0),
    e.FINAL_CONFIG.chart.userOptions.show && e.isDataset && (t.keepUserOptionState || t.userOptionsVisible) ? (l(), D(w, {
      ref: "defails",
      key: `user_options_${t.step}`,
      backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
      color: e.FINAL_CONFIG.chart.color,
      isPrinting: t.isPrinting,
      isImaging: t.isImaging,
      uid: t.uniqueId,
      hasTooltip: e.FINAL_CONFIG.chart.userOptions.buttons.tooltip && e.FINAL_CONFIG.chart.tooltip.show,
      hasPdf: e.FINAL_CONFIG.chart.userOptions.buttons.pdf,
      hasXls: e.FINAL_CONFIG.chart.userOptions.buttons.csv,
      hasImg: e.FINAL_CONFIG.chart.userOptions.buttons.img,
      hasLabel: e.FINAL_CONFIG.chart.userOptions.buttons.labels,
      hasTable: e.FINAL_CONFIG.chart.userOptions.buttons.table,
      hasStack: o.dataset.length > 1 && e.FINAL_CONFIG.chart.userOptions.buttons.stack,
      hasFullscreen: e.FINAL_CONFIG.chart.userOptions.buttons.fullscreen,
      isStacked: t.mutableConfig.isStacked,
      isFullscreen: t.isFullscreen,
      chartElement: a.$refs.chart,
      position: e.FINAL_CONFIG.chart.userOptions.position,
      isTooltip: t.mutableConfig.showTooltip,
      titles: { ...e.FINAL_CONFIG.chart.userOptions.buttonTitles },
      hasAnnotator: e.FINAL_CONFIG.chart.userOptions.buttons.annotator,
      isAnnotation: t.isAnnotator,
      onToggleFullscreen: e.toggleFullscreen,
      onGeneratePdf: e.generatePdf,
      onGenerateCsv: e.generateCsv,
      onGenerateImage: e.generateImage,
      onToggleTable: e.toggleTable,
      onToggleLabels: e.toggleLabels,
      onToggleStack: e.toggleStack,
      onToggleTooltip: e.toggleTooltip,
      onToggleAnnotator: e.toggleAnnotator,
      style: L({
        visibility: t.keepUserOptionState ? t.userOptionsVisible ? "visible" : "hidden" : "visible"
      })
    }, Be({ _: 2 }, [
      a.$slots.optionTooltip ? {
        name: "optionTooltip",
        fn: p(() => [
          S(a.$slots, "optionTooltip", {}, void 0, !0)
        ]),
        key: "0"
      } : void 0,
      a.$slots.optionPdf ? {
        name: "optionPdf",
        fn: p(() => [
          S(a.$slots, "optionPdf", {}, void 0, !0)
        ]),
        key: "1"
      } : void 0,
      a.$slots.optionCsv ? {
        name: "optionCsv",
        fn: p(() => [
          S(a.$slots, "optionCsv", {}, void 0, !0)
        ]),
        key: "2"
      } : void 0,
      a.$slots.optionImg ? {
        name: "optionImg",
        fn: p(() => [
          S(a.$slots, "optionImg", {}, void 0, !0)
        ]),
        key: "3"
      } : void 0,
      a.$slots.optionTable ? {
        name: "optionTable",
        fn: p(() => [
          S(a.$slots, "optionTable", {}, void 0, !0)
        ]),
        key: "4"
      } : void 0,
      a.$slots.optionLabels ? {
        name: "optionLabels",
        fn: p(() => [
          S(a.$slots, "optionLabels", {}, void 0, !0)
        ]),
        key: "5"
      } : void 0,
      a.$slots.optionStack ? {
        name: "optionStack",
        fn: p(() => [
          S(a.$slots, "optionStack", {}, void 0, !0)
        ]),
        key: "6"
      } : void 0,
      a.$slots.optionFullscreen ? {
        name: "optionFullscreen",
        fn: p(({ toggleFullscreen: r, isFullscreen: h }) => [
          S(a.$slots, "optionFullscreen", H(B({ toggleFullscreen: r, isFullscreen: h })), void 0, !0)
        ]),
        key: "7"
      } : void 0,
      a.$slots.optionAnnotator ? {
        name: "optionAnnotator",
        fn: p(({ toggleAnnotator: r, isAnnotator: h }) => [
          S(a.$slots, "optionAnnotator", H(B({ toggleAnnotator: r, isAnnotator: h })), void 0, !0)
        ]),
        key: "8"
      } : void 0
    ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasLabel", "hasTable", "hasStack", "hasFullscreen", "isStacked", "isFullscreen", "chartElement", "position", "isTooltip", "titles", "hasAnnotator", "isAnnotation", "onToggleFullscreen", "onGeneratePdf", "onGenerateCsv", "onGenerateImage", "onToggleTable", "onToggleLabels", "onToggleStack", "onToggleTooltip", "onToggleAnnotator", "style"])) : c("", !0),
    e.isDataset ? (l(), i("svg", {
      key: 4,
      xmlns: "http://www.w3.org/2000/svg",
      class: P([{ "vue-data-ui-fullscreen--on": t.isFullscreen, "vue-data-ui-fulscreen--off": !t.isFullscreen }, "vue-ui-xy-svg"]),
      width: "100%",
      viewBox: t.viewBox,
      style: L(`background: transparent; color:${e.FINAL_CONFIG.chart.color}; font-family:${e.FINAL_CONFIG.chart.fontFamily}`)
    }, [
      q(N),
      a.$slots["chart-background"] ? (l(), i("foreignObject", {
        key: 0,
        x: e.drawingArea.left + e.xPadding < 0 ? 0 : e.drawingArea.left + e.xPadding,
        y: e.drawingArea.top,
        width: e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries) < 0 ? 0 : e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries),
        height: e.drawingArea.height < 0 ? 0 : e.drawingArea.height,
        style: {
          pointerEvents: "none"
        }
      }, [
        S(a.$slots, "chart-background", {}, void 0, !0)
      ], 8, je)) : c("", !0),
      e.maxSeries > 0 ? (l(), i("g", $e, [
        f("g", et, [
          e.FINAL_CONFIG.chart.grid.labels.xAxis.showBaseline ? (l(), i("line", {
            key: 0,
            stroke: e.FINAL_CONFIG.chart.grid.stroke,
            "stroke-width": "1",
            x1: e.drawingArea.left + e.xPadding,
            x2: e.drawingArea.right - e.xPadding,
            y1: e.forceValidValue(e.drawingArea.bottom),
            y2: e.forceValidValue(e.drawingArea.bottom),
            "stroke-linecap": "round"
          }, null, 8, tt)) : c("", !0),
          t.mutableConfig.useIndividualScale ? e.FINAL_CONFIG.chart.grid.showHorizontalLines ? (l(!0), i(I, { key: 2 }, m(e.allScales, (r) => (l(), i("g", null, [
            r.id === t.selectedScale && r.yLabels.length ? (l(!0), i(I, { key: 0 }, m(r.yLabels, (h) => (l(), i("line", {
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.right - e.xPadding,
              y1: e.forceValidValue(h.y),
              y2: e.forceValidValue(h.y),
              stroke: r.color,
              "stroke-width": 0.5,
              "stroke-linecap": "round"
            }, null, 8, it))), 256)) : r.yLabels.length ? (l(!0), i(I, { key: 1 }, m(r.yLabels, (h) => (l(), i("line", {
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.right - e.xPadding,
              y1: e.forceValidValue(h.y),
              y2: e.forceValidValue(h.y),
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": 0.5,
              "stroke-linecap": "round"
            }, null, 8, st))), 256)) : c("", !0)
          ]))), 256)) : c("", !0) : (l(), i(I, { key: 1 }, [
            e.FINAL_CONFIG.chart.grid.labels.yAxis.showBaseline ? (l(), i("line", {
              key: 0,
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": "1",
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.left + e.xPadding,
              y1: e.forceValidValue(e.drawingArea.top),
              y2: e.forceValidValue(e.drawingArea.bottom),
              "stroke-linecap": "round"
            }, null, 8, at)) : c("", !0),
            e.FINAL_CONFIG.chart.grid.showHorizontalLines ? (l(), i("g", rt, [
              (l(!0), i(I, null, m(e.yLabels, (r) => (l(), i("line", {
                x1: e.drawingArea.left + e.xPadding,
                x2: e.drawingArea.right - e.xPadding,
                y1: e.forceValidValue(r.y),
                y2: e.forceValidValue(r.y),
                stroke: e.FINAL_CONFIG.chart.grid.stroke,
                "stroke-width": 0.5,
                "stroke-linecap": "round"
              }, null, 8, lt))), 256))
            ])) : c("", !0)
          ], 64)),
          e.FINAL_CONFIG.chart.grid.showVerticalLines ? (l(), i("g", nt, [
            (l(!0), i(I, null, m(e.maxSeries + (e.FINAL_CONFIG.chart.grid.position === "middle" ? 1 : 0), (r, h) => (l(), i("line", {
              key: `grid_vertical_line_${h}`,
              x1: e.drawingArea.width / e.maxSeries * h + e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.width / e.maxSeries * h + e.drawingArea.left + e.xPadding,
              y1: e.forceValidValue(e.drawingArea.top),
              y2: e.forceValidValue(e.drawingArea.bottom),
              "stroke-width": "0.5",
              stroke: e.FINAL_CONFIG.chart.grid.stroke
            }, null, 8, ht))), 128))
          ])) : c("", !0)
        ]),
        (l(!0), i(I, null, m(e.barSet, (r, h) => (l(), i("defs", {
          key: `def_rect_${h}`
        }, [
          f("linearGradient", {
            id: `rectGradient_pos_${h}_${t.uniqueId}`,
            x2: "0%",
            y2: "100%"
          }, [
            f("stop", {
              offset: "0%",
              "stop-color": r.color
            }, null, 8, ct),
            f("stop", {
              offset: "62%",
              "stop-color": `${e.shiftHue(r.color, 0.02)}`
            }, null, 8, dt),
            f("stop", {
              offset: "100%",
              "stop-color": `${e.shiftHue(r.color, 0.05)}`
            }, null, 8, ut)
          ], 8, ot),
          f("linearGradient", {
            id: `rectGradient_neg_${h}_${t.uniqueId}`,
            x2: "0%",
            y2: "100%"
          }, [
            f("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(r.color, 0.05)}`
            }, null, 8, ft),
            f("stop", {
              offset: "38%",
              "stop-color": `${e.shiftHue(r.color, 0.02)}`
            }, null, 8, It),
            f("stop", {
              offset: "100%",
              "stop-color": r.color
            }, null, 8, mt)
          ], 8, gt)
        ]))), 128)),
        (l(!0), i(I, null, m(e.plotSet, (r, h) => (l(), i("defs", {
          key: `def_plot_${h}`
        }, [
          f("radialGradient", {
            id: `plotGradient_${h}_${t.uniqueId}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            f("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(r.color, 0.05)}`
            }, null, 8, xt),
            f("stop", {
              offset: "100%",
              "stop-color": r.color
            }, null, 8, bt)
          ], 8, Nt)
        ]))), 128)),
        (l(!0), i(I, null, m(e.lineSet, (r, h) => (l(), i("defs", {
          key: `def_line_${h}`
        }, [
          f("radialGradient", {
            id: `lineGradient_${h}_${t.uniqueId}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            f("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(r.color, 0.05)}`
            }, null, 8, _t),
            f("stop", {
              offset: "100%",
              "stop-color": r.color
            }, null, 8, At)
          ], 8, Ft),
          f("linearGradient", {
            id: `areaGradient_${h}_${t.uniqueId}`,
            x1: "0%",
            x2: "100%",
            y1: "0%",
            y2: "0%"
          }, [
            f("stop", {
              offset: "0%",
              "stop-color": `${e.setOpacity(e.shiftHue(r.color, 0.03), e.FINAL_CONFIG.line.area.opacity)}`
            }, null, 8, Lt),
            f("stop", {
              offset: "100%",
              "stop-color": `${e.setOpacity(r.color, e.FINAL_CONFIG.line.area.opacity)}`
            }, null, 8, Ct)
          ], 8, yt)
        ]))), 128)),
        (l(!0), i(I, null, m(e.highlightAreas, (r) => (l(), i("g", null, [
          r.show ? (l(!0), i(I, { key: 0 }, m(r.span, (h, n) => (l(), i("g", null, [
            f("rect", {
              style: L({
                transition: "none",
                opacity: r.from + n >= t.slicer.start && r.from + n <= t.slicer.end - 1 ? 1 : 0
              }),
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (r.from + n - t.slicer.start),
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: e.setOpacity(r.color, r.opacity)
            }, null, 12, St),
            r.caption.text && n === 0 ? (l(), i("foreignObject", {
              key: 0,
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (r.from + n - t.slicer.start) - (r.caption.width === "auto" ? 0 : r.caption.width / 2 - e.drawingArea.width / e.maxSeries * r.span / 2),
              y: e.drawingArea.top + r.caption.offsetY,
              style: L({
                overflow: "visible",
                opacity: r.to >= t.slicer.start && r.from < t.slicer.end ? 1 : 0
              }),
              height: "1",
              width: r.caption.width === "auto" ? e.drawingArea.width / e.maxSeries * r.span : r.caption.width
            }, [
              f("div", {
                style: L(`padding:${r.caption.padding}px;text-align:${r.caption.textAlign};font-size:${r.caption.fontSize}px;color:${r.caption.color};font-weight:${r.caption.bold ? "bold" : "normal"}`)
              }, k(r.caption.text), 5)
            ], 12, kt)) : c("", !0)
          ]))), 256)) : c("", !0)
        ]))), 256)),
        f("g", null, [
          (l(!0), i(I, null, m(e.maxSeries, (r, h) => (l(), i("g", {
            key: `tooltip_trap_highlighter_${h}`
          }, [
            f("rect", {
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * h,
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: [t.selectedMinimapIndex, t.selectedSerieIndex, t.selectedRowIndex].includes(h) ? e.setOpacity(e.FINAL_CONFIG.chart.highlighter.color, e.FINAL_CONFIG.chart.highlighter.opacity) : "transparent"
            }, null, 8, wt)
          ]))), 128))
        ]),
        e.barSet.length ? (l(!0), i(I, { key: 0 }, m(e.barSet, (r, h) => (l(), i("g", {
          key: `serie_bar_${h}`,
          class: P(`serie_bar_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (l(!0), i(I, null, m(r.plots, (n, d) => (l(), i("g", {
            key: `bar_plot_${h}_${d}`
          }, [
            e.canShowValue(n.value) ? (l(), i("rect", {
              key: 0,
              x: e.calcRectX(n),
              y: t.mutableConfig.useIndividualScale ? e.calcIndividualRectY(n) : e.calcRectY(n),
              height: t.mutableConfig.useIndividualScale ? Math.abs(e.calcIndividualHeight(n)) : Math.abs(e.calcRectHeight(n)),
              width: e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap),
              rx: e.FINAL_CONFIG.bar.borderRadius,
              fill: e.FINAL_CONFIG.bar.useGradient ? n.value >= 0 ? `url(#rectGradient_pos_${h}_${t.uniqueId})` : `url(#rectGradient_neg_${h}_${t.uniqueId})` : r.color,
              stroke: e.FINAL_CONFIG.bar.border.useSerieColor ? r.color : e.FINAL_CONFIG.bar.border.stroke,
              "stroke-width": e.FINAL_CONFIG.bar.border.strokeWidth
            }, null, 8, Ot)) : c("", !0),
            e.canShowValue(n.value) && a.$slots.pattern ? (l(), i("rect", {
              key: 1,
              x: e.calcRectX(n),
              y: t.mutableConfig.useIndividualScale ? e.calcIndividualRectY(n) : e.calcRectY(n),
              height: t.mutableConfig.useIndividualScale ? Math.abs(e.calcIndividualHeight(n)) : Math.abs(e.calcRectHeight(n)),
              width: e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap),
              rx: e.FINAL_CONFIG.bar.borderRadius,
              fill: `url(#pattern_${t.uniqueId}_${r.slotAbsoluteIndex})`,
              stroke: e.FINAL_CONFIG.bar.border.useSerieColor ? r.color : e.FINAL_CONFIG.bar.border.stroke,
              "stroke-width": e.FINAL_CONFIG.bar.border.strokeWidth
            }, null, 8, Gt)) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (l(), i("foreignObject", {
              key: 2,
              style: { overflow: "visible" },
              height: "12",
              width: (e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) / 2) + e.FINAL_CONFIG.chart.comments.width,
              x: e.calcRectX(n) - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: e.checkNaN(n.y) + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              S(a.$slots, "plot-comment", {
                plot: { ...n, color: r.color, seriesIndex: h, datapointIndex: d }
              }, void 0, !0)
            ], 8, vt)) : c("", !0)
          ]))), 128)),
          Object.hasOwn(r, "useProgression") && r.useProgression === !0 && !isNaN(e.calcLinearProgression(r.plots).trend) ? (l(), i("g", zt, [
            f("defs", null, [
              f("marker", {
                id: `bar_arrow_${h}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                f("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: r.color
                }, null, 8, pt)
              ], 8, Mt)
            ]),
            r.plots.length > 1 ? (l(), i("line", {
              key: 0,
              x1: e.calcLinearProgression(r.plots).x1,
              x2: e.calcLinearProgression(r.plots).x2,
              y1: e.forceValidValue(e.calcLinearProgression(r.plots).y1),
              y2: e.forceValidValue(e.calcLinearProgression(r.plots).y2),
              "stroke-width": 1,
              stroke: r.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#bar_arrow_${h})`
            }, null, 8, Vt)) : c("", !0),
            r.plots.length > 1 ? (l(), i("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(r.plots).x2,
              y: e.calcLinearProgression(r.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: r.color
            }, k(e.dataLabel({
              v: e.calcLinearProgression(r.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, Tt)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)) : c("", !0),
        !t.mutableConfig.useIndividualScale && e.FINAL_CONFIG.chart.grid.labels.zeroLine.show ? (l(), i("line", {
          key: 1,
          stroke: e.FINAL_CONFIG.chart.grid.stroke,
          "stroke-width": "1",
          x1: e.drawingArea.left + e.xPadding,
          x2: e.drawingArea.right - e.xPadding,
          y1: e.forceValidValue(e.zero),
          y2: e.forceValidValue(e.zero),
          "stroke-linecap": "round"
        }, null, 8, Pt)) : c("", !0),
        e.FINAL_CONFIG.chart.highlighter.useLine && (![null, void 0].includes(t.selectedSerieIndex) || ![null, void 0].includes(t.selectedMinimapIndex)) ? (l(), i("g", Rt, [
          f("line", {
            x1: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) + e.drawingArea.width / e.maxSeries / 2,
            x2: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) + e.drawingArea.width / e.maxSeries / 2,
            y1: e.forceValidValue(e.drawingArea.top),
            y2: e.forceValidValue(e.drawingArea.bottom),
            stroke: e.FINAL_CONFIG.chart.highlighter.color,
            "stroke-width": e.FINAL_CONFIG.chart.highlighter.lineWidth,
            "stroke-dasharray": e.FINAL_CONFIG.chart.highlighter.lineDasharray,
            "stroke-linecap": "round",
            style: { transition: "none !important", animation: "none !important", "pointer-events": "none" }
          }, null, 8, Dt)
        ])) : c("", !0),
        e.FINAL_CONFIG.chart.grid.frame.show ? (l(), i("rect", {
          key: 3,
          style: { pointerEvents: "none", transition: "none" },
          x: e.drawingArea.left + e.xPadding < 0 ? 0 : e.drawingArea.left + e.xPadding,
          y: e.drawingArea.top,
          width: e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries) < 0 ? 0 : e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries),
          height: e.drawingArea.height < 0 ? 0 : e.drawingArea.height,
          fill: "transparent",
          stroke: e.FINAL_CONFIG.chart.grid.frame.stroke,
          "stroke-width": e.FINAL_CONFIG.chart.grid.frame.strokeWidth,
          "stroke-linecap": e.FINAL_CONFIG.chart.grid.frame.strokeLinecap,
          "stroke-linejoin": e.FINAL_CONFIG.chart.grid.frame.strokeLinejoin,
          "stroke-dasharray": e.FINAL_CONFIG.chart.grid.frame.strokeDasharray
        }, null, 8, Ht)) : c("", !0),
        e.FINAL_CONFIG.chart.grid.labels.show ? (l(), i("g", Bt, [
          t.mutableConfig.useIndividualScale ? (l(), i(I, { key: 0 }, [
            (l(!0), i(I, null, m(e.allScales, (r) => (l(), i("g", null, [
              f("line", {
                x1: r.x + e.xPadding,
                x2: r.x + e.xPadding,
                y1: t.mutableConfig.isStacked ? e.forceValidValue(e.drawingArea.bottom - r.yOffset - r.individualHeight) : e.forceValidValue(e.drawingArea.top),
                y2: t.mutableConfig.isStacked ? e.forceValidValue(e.drawingArea.bottom - r.yOffset) : e.forceValidValue(e.drawingArea.bottom),
                stroke: r.color,
                "stroke-width": e.FINAL_CONFIG.chart.grid.stroke,
                "stroke-linecap": "round",
                style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.3 : 1};transition:opacity 0.2s ease-in-out`)
              }, null, 12, Wt)
            ]))), 256)),
            (l(!0), i(I, null, m(e.allScales, (r) => (l(), i("g", {
              style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.3 : 1};transition:opacity 0.2s ease-in-out`)
            }, [
              f("text", {
                fill: r.color,
                "font-size": t.fontSizes.dataLabels,
                "text-anchor": "middle",
                transform: `translate(${r.x - e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth + 5 + e.xPadding}, ${t.mutableConfig.isStacked ? e.drawingArea.bottom - r.yOffset - r.individualHeight / 2 : e.drawingArea.top + e.drawingArea.height / 2}) rotate(-90)`
              }, k(r.name) + " " + k(r.scaleLabel ? `- ${r.scaleLabel}` : ""), 9, Et),
              (l(!0), i(I, null, m(r.yLabels, (h, n) => (l(), i("line", {
                x1: r.x - 3 + e.xPadding,
                x2: r.x + e.xPadding,
                y1: e.forceValidValue(h.y),
                y2: e.forceValidValue(h.y),
                stroke: r.color,
                "stroke-width": 1,
                "stroke-linecap": "round"
              }, null, 8, Yt))), 256)),
              (l(!0), i(I, null, m(r.yLabels, (h, n) => (l(), i("text", {
                x: r.x - 5 + e.xPadding,
                y: e.forceValidValue(h.y) + t.fontSizes.dataLabels / 3,
                "font-size": t.fontSizes.dataLabels,
                "text-anchor": "end",
                fill: r.color
              }, k(e.applyDataLabel(
                e.FINAL_CONFIG.chart.grid.labels.yAxis.formatter,
                h.value,
                e.dataLabel({
                  p: h.prefix,
                  v: h.value,
                  s: h.suffix,
                  r: 1
                }),
                { datapoint: h.datapoint, seriesIndex: n }
              )), 9, qt))), 256))
            ], 4))), 256))
          ], 64)) : (l(!0), i(I, { key: 1 }, m(e.yLabels, (r, h) => (l(), i("g", {
            key: `yLabel_${h}`
          }, [
            e.canShowValue(r) && r.value >= e.niceScale.min && r.value <= e.niceScale.max ? (l(), i("line", {
              key: 0,
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.left - 5 + e.xPadding,
              y1: e.forceValidValue(r.y),
              y2: e.forceValidValue(r.y),
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": "1",
              "stroke-linecap": "round"
            }, null, 8, Xt)) : c("", !0),
            r.value >= e.niceScale.min && r.value <= e.niceScale.max ? (l(), i("text", {
              key: 1,
              x: e.drawingArea.left - 7 + e.xPadding,
              y: e.checkNaN(r.y + t.fontSizes.dataLabels / 3),
              "font-size": t.fontSizes.dataLabels,
              "text-anchor": "end",
              fill: e.FINAL_CONFIG.chart.grid.labels.color
            }, k(e.canShowValue(r.value) ? e.applyDataLabel(
              e.FINAL_CONFIG.chart.grid.labels.yAxis.formatter,
              r.value,
              e.dataLabel({
                p: r.prefix,
                v: r.value,
                s: r.suffix,
                r: 1
              })
            ) : ""), 9, Ut)) : c("", !0)
          ]))), 128))
        ])) : c("", !0),
        (l(!0), i(I, null, m(e.plotSet, (r, h) => (l(), i("g", {
          key: `serie_plot_${h}`,
          class: P(`serie_plot_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (l(!0), i(I, null, m(r.plots, (n, d) => (l(), i("g", {
            key: `circle_plot_${h}_${d}`
          }, [
            n && e.canShowValue(n.value) ? (l(), D(b, {
              key: 0,
              shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(r.shape) ? r.shape : "circle",
              color: e.FINAL_CONFIG.plot.useGradient ? `url(#plotGradient_${h}_${t.uniqueId})` : e.FINAL_CONFIG.plot.dot.useSerieColor ? r.color : e.FINAL_CONFIG.plot.dot.fill,
              plot: { x: e.checkNaN(n.x), y: e.checkNaN(n.y) },
              radius: t.selectedSerieIndex !== null && t.selectedSerieIndex === d || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === d ? (t.plotRadii.plot || 6) * 1.5 : t.plotRadii.plot || 6,
              stroke: e.FINAL_CONFIG.plot.dot.useSerieColor ? e.FINAL_CONFIG.chart.backgroundColor : r.color,
              strokeWidth: e.FINAL_CONFIG.plot.dot.strokeWidth
            }, null, 8, ["shape", "color", "plot", "radius", "stroke", "strokeWidth"])) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (l(), i("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: e.FINAL_CONFIG.chart.comments.width,
              x: n.x - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: n.y + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              f("div", Jt, [
                S(a.$slots, "plot-comment", {
                  plot: { ...n, color: r.color, seriesIndex: h, datapointIndex: d }
                }, void 0, !0)
              ])
            ], 8, Zt)) : c("", !0)
          ]))), 128)),
          Object.hasOwn(r, "useProgression") && r.useProgression === !0 && !isNaN(e.calcLinearProgression(r.plots).trend) ? (l(), i("g", Kt, [
            f("defs", null, [
              f("marker", {
                id: `plot_arrow_${h}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                f("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: r.color
                }, null, 8, jt)
              ], 8, Qt)
            ]),
            r.plots.length > 1 ? (l(), i("line", {
              key: 0,
              x1: e.calcLinearProgression(r.plots).x1,
              x2: e.calcLinearProgression(r.plots).x2,
              y1: e.forceValidValue(e.calcLinearProgression(r.plots).y1),
              y2: e.forceValidValue(e.calcLinearProgression(r.plots).y2),
              "stroke-width": 1,
              stroke: r.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#plot_arrow_${h})`
            }, null, 8, $t)) : c("", !0),
            r.plots.length > 1 ? (l(), i("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(r.plots).x2,
              y: e.calcLinearProgression(r.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: r.color
            }, k(e.dataLabel({
              v: e.calcLinearProgression(r.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, ea)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)),
        (l(!0), i(I, null, m(e.lineSet, (r, h) => (l(), i("g", {
          key: `serie_line_${h}`,
          class: P(`serie_line_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          r.smooth && r.plots.length > 1 ? (l(), i("path", {
            key: 0,
            d: `M${r.curve}`,
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth + 1,
            "stroke-dasharray": r.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none"
          }, null, 8, ta)) : r.plots.length > 1 ? (l(), i("g", aa, [
            (l(!0), i(I, null, m(r.plots, (n, d) => (l(), i("g", {
              key: `line_${h}_${d}`
            }, [
              n && d < r.plots.length - 1 && r.plots[d + 1] && e.canShowValue(n.value) && e.canShowValue(r.plots[d + 1].value) ? (l(), i("line", {
                key: 0,
                x1: n.x,
                x2: r.plots[d + 1].x,
                y1: e.forceValidValue(n.y),
                y2: e.forceValidValue(r.plots[d + 1].y),
                stroke: e.FINAL_CONFIG.chart.backgroundColor,
                "stroke-width": e.FINAL_CONFIG.line.strokeWidth + 1,
                "stroke-dasharray": r.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
                "stroke-linejoin": "round",
                "stroke-linecap": "round"
              }, null, 8, ra)) : c("", !0)
            ]))), 128))
          ])) : c("", !0)
        ], 6))), 128)),
        a.$slots.pattern ? (l(), i("defs", la, [
          (l(!0), i(I, null, m(e.safeDataset, (r, h) => S(a.$slots, "pattern", We({
            key: `serie_pattern_slot_${h}`
          }, { ...r, seriesIndex: r.slotAbsoluteIndex, patternId: `pattern_${t.uniqueId}_${h}` }), void 0, !0)), 128))
        ])) : c("", !0),
        (l(!0), i(I, null, m(e.lineSet, (r, h) => (l(), i("g", {
          key: `serie_line_${h}`,
          class: P(`serie_line_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          r.useArea && r.plots.length > 1 ? (l(), i("g", ia, [
            r.smooth ? (l(), i(I, { key: 0 }, [
              f("path", {
                d: `M ${r.plots[0] ? r.plots[0].x : Math.min(...r.plots.filter((n) => !!n).map((n) => n.x))},${t.mutableConfig.isStacked ? e.drawingArea.bottom - r.yOffset : e.drawingArea.bottom} ${r.curve} L ${r.plots.at(-1) ? r.plots.at(-1).x : e.drawingArea.left + e.slot.line * h + e.slot.line / 2},${t.mutableConfig.isStacked ? e.drawingArea.bottom - r.yOffset : e.drawingArea.bottom} Z`,
                fill: e.FINAL_CONFIG.line.area.useGradient ? `url(#areaGradient_${h}_${t.uniqueId})` : e.setOpacity(r.color, e.FINAL_CONFIG.line.area.opacity)
              }, null, 8, sa),
              a.$slots.pattern ? (l(), i("path", {
                key: 0,
                d: `M ${r.plots[0] ? r.plots[0].x : Math.min(...r.plots.filter((n) => !!n).map((n) => n.x))},${t.mutableConfig.isStacked ? e.drawingArea.bottom - r.yOffset : e.drawingArea.bottom} ${r.curve} L ${r.plots.at(-1) ? r.plots.at(-1).x : e.drawingArea.left + e.slot.line * h + e.slot.line / 2},${t.mutableConfig.isStacked ? e.drawingArea.bottom - r.yOffset : e.drawingArea.bottom} Z`,
                fill: `url(#pattern_${t.uniqueId}_${r.slotAbsoluteIndex})`
              }, null, 8, na)) : c("", !0)
            ], 64)) : (l(), i(I, { key: 1 }, [
              f("path", {
                d: `M${r.area}Z`,
                fill: e.FINAL_CONFIG.line.area.useGradient ? `url(#areaGradient_${h}_${t.uniqueId})` : e.setOpacity(r.color, e.FINAL_CONFIG.line.area.opacity)
              }, null, 8, ha),
              a.$slots.pattern ? (l(), i("path", {
                key: 0,
                d: `M${r.area}Z`,
                fill: `url(#pattern_${t.uniqueId}_${r.slotAbsoluteIndex})`
              }, null, 8, oa)) : c("", !0)
            ], 64))
          ])) : c("", !0),
          r.smooth && r.plots.length > 1 ? (l(), i("path", {
            key: 1,
            d: `M${r.curve}`,
            stroke: r.color,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth,
            "stroke-dasharray": r.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none"
          }, null, 8, ca)) : r.plots.length > 1 ? (l(), i("g", da, [
            (l(!0), i(I, null, m(r.plots, (n, d) => (l(), i("g", {
              key: `line_${h}_${d}`
            }, [
              n && d < r.plots.length - 1 && r.plots[d + 1] && e.canShowValue(n.value) && e.canShowValue(r.plots[d + 1].value) ? (l(), i("line", {
                key: 0,
                x1: n.x,
                x2: r.plots[d + 1].x,
                y1: e.forceValidValue(n.y),
                y2: e.forceValidValue(r.plots[d + 1].y),
                stroke: r.color,
                "stroke-width": e.FINAL_CONFIG.line.strokeWidth,
                "stroke-dasharray": r.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
                "stroke-linejoin": "round",
                "stroke-linecap": "round"
              }, null, 8, ua)) : c("", !0)
            ]))), 128))
          ])) : c("", !0),
          (l(!0), i(I, null, m(r.plots, (n, d) => (l(), i("g", {
            key: `circle_line_${h}_${d}`
          }, [
            n && e.canShowValue(n.value) ? (l(), D(b, {
              key: 0,
              shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(r.shape) ? r.shape : "circle",
              color: e.FINAL_CONFIG.line.useGradient ? `url(#lineGradient_${h}_${t.uniqueId})` : e.FINAL_CONFIG.line.dot.useSerieColor ? r.color : e.FINAL_CONFIG.line.dot.fill,
              plot: { x: e.checkNaN(n.x), y: e.checkNaN(n.y) },
              radius: t.selectedSerieIndex !== null && t.selectedSerieIndex === d || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === d ? (t.plotRadii.line || 6) * 1.5 : t.plotRadii.line || 6,
              stroke: e.FINAL_CONFIG.line.dot.useSerieColor ? e.FINAL_CONFIG.chart.backgroundColor : r.color,
              strokeWidth: e.FINAL_CONFIG.line.dot.strokeWidth
            }, null, 8, ["shape", "color", "plot", "radius", "stroke", "strokeWidth"])) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (l(), i("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: e.FINAL_CONFIG.chart.comments.width,
              x: n.x - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: n.y + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              f("div", fa, [
                S(a.$slots, "plot-comment", {
                  plot: { ...n, color: r.color, seriesIndex: h, datapointIndex: d }
                }, void 0, !0)
              ])
            ], 8, ga)) : c("", !0)
          ]))), 128)),
          Object.hasOwn(r, "useProgression") && r.useProgression === !0 && !isNaN(e.calcLinearProgression(r.plots).trend) ? (l(), i("g", Ia, [
            f("defs", null, [
              f("marker", {
                id: `line_arrow_${h}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                f("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: r.color
                }, null, 8, Na)
              ], 8, ma)
            ]),
            r.plots.length > 1 ? (l(), i("line", {
              key: 0,
              x1: e.calcLinearProgression(r.plots).x1,
              x2: e.calcLinearProgression(r.plots).x2,
              y1: e.forceValidValue(e.calcLinearProgression(r.plots).y1),
              y2: e.forceValidValue(e.calcLinearProgression(r.plots).y2),
              "stroke-width": 1,
              stroke: r.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#line_arrow_${h})`
            }, null, 8, xa)) : c("", !0),
            r.plots.length > 1 ? (l(), i("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(r.plots).x2,
              y: e.calcLinearProgression(r.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: r.color
            }, k(e.dataLabel({
              v: e.calcLinearProgression(r.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, ba)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)),
        (e.FINAL_CONFIG.bar.labels.show || e.FINAL_CONFIG.bar.serieName.show) && t.mutableConfig.dataLabels.show ? (l(), i("g", Fa, [
          (l(!0), i(I, null, m(e.barSet, (r, h) => (l(), i("g", {
            key: `xLabel_bar_${h}`,
            class: P(`xLabel_bar_${h}`),
            style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (l(!0), i(I, null, m(r.plots, (n, d) => (l(), i("g", {
              key: `xLabel_bar_${h}_${d}`
            }, [
              n && (!Object.hasOwn(r, "dataLabels") || r.dataLabels === !0 || t.selectedSerieIndex !== null && t.selectedSerieIndex === d || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === d) && e.FINAL_CONFIG.bar.labels.show ? (l(), i("text", {
                key: 0,
                x: t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? n.x + e.slot.line / 2 : e.calcRectX(n) + e.calcRectWidth() / 2 - e.barPeriodGap / 2,
                y: e.checkNaN(n.y) + (n.value >= 0 ? e.FINAL_CONFIG.bar.labels.offsetY : -e.FINAL_CONFIG.bar.labels.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.bar.labels.color
              }, k(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.bar.labels.formatter,
                n.value,
                e.dataLabel({
                  p: r.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: r.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.bar.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: r
                }
              ) : ""), 9, _a)) : c("", !0),
              n && e.FINAL_CONFIG.bar.serieName.show ? (l(), i("text", {
                key: 1,
                x: t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? n.x + e.slot.line / 2 : n.x + e.calcRectWidth() * 1.1,
                y: n.y + (n.value > 0 ? e.FINAL_CONFIG.bar.serieName.offsetY : -e.FINAL_CONFIG.bar.serieName.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.bar.serieName.useSerieColor ? r.color : e.FINAL_CONFIG.bar.serieName.color,
                "font-weight": e.FINAL_CONFIG.bar.serieName.bold ? "bold" : "normal"
              }, k(e.FINAL_CONFIG.bar.serieName.useAbbreviation ? e.abbreviate({ source: r.name, length: e.FINAL_CONFIG.bar.serieName.abbreviationSize }) : r.name), 9, Aa)) : c("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : c("", !0),
        e.FINAL_CONFIG.plot.labels.show && t.mutableConfig.dataLabels.show ? (l(), i("g", ya, [
          (l(!0), i(I, null, m(e.plotSet, (r, h) => (l(), i("g", {
            key: `xLabel_plot_${h}`,
            class: P(`xLabel_plot_${h}`),
            style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (l(!0), i(I, null, m(r.plots, (n, d) => (l(), i("g", {
              key: `xLabel_plot_${h}_${d}`
            }, [
              n && !Object.hasOwn(r, "dataLabels") || r.dataLabels === !0 || t.selectedSerieIndex !== null && t.selectedSerieIndex === d || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === d ? (l(), i("text", {
                key: 0,
                x: n.x,
                y: n.y + e.FINAL_CONFIG.plot.labels.offsetY,
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.plot.labels.color
              }, k(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.plot.labels.formatter,
                n.value,
                e.dataLabel({
                  p: r.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: r.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.plot.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: r
                }
              ) : ""), 9, La)) : c("", !0),
              n && d === 0 && r.useTag && r.useTag === "start" ? (l(), i("foreignObject", {
                key: 1,
                x: n.x,
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                f("div", {
                  style: L(`padding: 3px; background:${e.setOpacity(r.color, 80)};color:${e.adaptColorToBackground(r.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, k(r.name), 5)
              ], 8, Ca)) : c("", !0),
              n && d === r.plots.length - 1 && r.useTag && r.useTag === "end" ? (l(), i("foreignObject", {
                key: 2,
                x: n.x - r.name.length * (t.fontSizes.plotLabels / 2),
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                f("div", {
                  style: L(`padding: 3px; background:${e.setOpacity(r.color, 80)};color:${e.adaptColorToBackground(r.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, k(r.name), 5)
              ], 8, Sa)) : c("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : c("", !0),
        e.FINAL_CONFIG.line.labels.show && t.mutableConfig.dataLabels.show ? (l(), i("g", ka, [
          (l(!0), i(I, null, m(e.lineSet, (r, h) => (l(), i("g", {
            key: `xLabel_line_${h}`,
            class: P(`xLabel_line_${h}`),
            style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (l(!0), i(I, null, m(r.plots, (n, d) => (l(), i("g", {
              key: `xLabel_line_${h}_${d}`
            }, [
              n && !Object.hasOwn(r, "dataLabels") || r.dataLabels === !0 || t.selectedSerieIndex !== null && t.selectedSerieIndex === d || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === d ? (l(), i("text", {
                key: 0,
                x: n.x,
                y: n.y + (n.value >= 0 ? e.FINAL_CONFIG.line.labels.offsetY : -e.FINAL_CONFIG.line.labels.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.line.labels.color
              }, k(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.line.labels.formatter,
                n.value,
                e.dataLabel({
                  p: r.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: r.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.line.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: r
                }
              ) : ""), 9, wa)) : c("", !0),
              n && d === 0 && r.useTag && r.useTag === "start" ? (l(), i("foreignObject", {
                key: 1,
                x: n.x,
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                f("div", {
                  style: L(`padding: 3px; background:${e.setOpacity(r.color, 80)};color:${e.adaptColorToBackground(r.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, k(r.name), 5)
              ], 8, Oa)) : c("", !0),
              n && d === r.plots.length - 1 && r.useTag && r.useTag === "end" ? (l(), i("foreignObject", {
                key: 2,
                x: n.x - r.name.length * (t.fontSizes.plotLabels / 2),
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                f("div", {
                  style: L(`padding: 3px; background:${e.setOpacity(r.color, 80)};color:${e.adaptColorToBackground(r.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, k(r.name), 5)
              ], 8, Ga)) : c("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : c("", !0),
        (l(!0), i(I, null, m(e.lineSet, (r, h) => (l(), i("g", {
          key: `xLabel_line_${h}`,
          class: P(`xLabel_line_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (l(!0), i(I, null, m(r.plots, (n, d) => (l(), i("g", {
            key: `xLabel_line_${h}_${d}`
          }, [
            n && d === 0 && r.showSerieName && r.showSerieName === "start" ? (l(), i("text", {
              key: 0,
              x: n.x - t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "end",
              fill: r.color,
              innerHTML: e.createTSpans({
                content: r.name,
                fontSize: t.fontSizes.plotLabels,
                fill: r.color,
                x: n.x - t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, va)) : c("", !0),
            n && d === r.plots.length - 1 && r.showSerieName && r.showSerieName === "end" ? (l(), i("text", {
              key: 1,
              x: n.x + t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "start",
              fill: r.color,
              innerHTML: e.createTSpans({
                content: r.name,
                fontSize: t.fontSizes.plotLabels,
                fill: r.color,
                x: n.x + t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, za)) : c("", !0)
          ]))), 128))
        ], 6))), 128)),
        (l(!0), i(I, null, m(e.plotSet, (r, h) => (l(), i("g", {
          key: `xLabel_plot_${h}`,
          class: P(`xLabel_plot_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (l(!0), i(I, null, m(r.plots, (n, d) => (l(), i("g", {
            key: `xLabel_plot_${h}_${d}`
          }, [
            n && d === 0 && r.showSerieName && r.showSerieName === "start" ? (l(), i("text", {
              key: 0,
              x: n.x - t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "end",
              fill: r.color,
              innerHTML: e.createTSpans({
                content: r.name,
                fontSize: t.fontSizes.plotLabels,
                fill: r.color,
                x: n.x - t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, Ma)) : c("", !0),
            n && d === r.plots.length - 1 && r.showSerieName && r.showSerieName === "end" ? (l(), i("text", {
              key: 1,
              x: n.x + t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "start",
              fill: r.color,
              innerHTML: e.createTSpans({
                content: r.name,
                fontSize: t.fontSizes.plotLabels,
                fill: r.color,
                x: n.x + t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, pa)) : c("", !0)
          ]))), 128))
        ], 6))), 128)),
        t.mutableConfig.useIndividualScale && !t.mutableConfig.isStacked ? (l(!0), i(I, { key: 9 }, m(e.allScales, (r) => (l(), i("rect", {
          x: r.x - e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth + e.xPadding,
          y: e.drawingArea.top,
          width: e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth,
          height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
          fill: t.selectedScale === r.id ? e.setOpacity(r.color, 20) : "transparent",
          onMouseenter: (h) => t.selectedScale = r.id,
          onMouseleave: s[0] || (s[0] = (h) => t.selectedScale = null)
        }, null, 40, Va))), 256)) : c("", !0),
        f("g", null, [
          e.FINAL_CONFIG.chart.grid.labels.axis.yLabel && !t.mutableConfig.useIndividualScale ? (l(), i("text", {
            key: 0,
            "font-size": t.fontSizes.yAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.color,
            transform: `translate(${t.fontSizes.yAxis + e.FINAL_CONFIG.chart.grid.labels.axis.yLabelOffsetX}, ${e.drawingArea.top + e.drawingArea.height / 2}) rotate(-90)`,
            "text-anchor": "middle",
            style: { transition: "none" }
          }, k(e.FINAL_CONFIG.chart.grid.labels.axis.yLabel), 9, Ta)) : c("", !0),
          e.FINAL_CONFIG.chart.grid.labels.axis.xLabel ? (l(), i("text", {
            key: 1,
            "text-anchor": "middle",
            x: t.width / 2,
            y: e.drawingArea.bottom + t.fontSizes.yAxis + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.axis.xLabelOffsetY,
            "font-size": t.fontSizes.yAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.color
          }, k(e.FINAL_CONFIG.chart.grid.labels.axis.xLabel), 9, Pa)) : c("", !0)
        ]),
        e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.show ? (l(), i("g", Ra, [
          a.$slots["time-label"] ? (l(!0), i(I, { key: 0 }, m(e.timeLabels, (r, h) => (l(), i("g", {
            key: `time_label_${h}`
          }, [
            S(a.$slots, "time-label", H(B({
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * h + e.drawingArea.width / e.maxSeries / 2,
              y: e.drawingArea.bottom + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.yOffset,
              fontSize: t.fontSizes.xAxis,
              fill: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.color,
              transform: `translate(${e.drawingArea.left + e.drawingArea.width / e.maxSeries * h + e.drawingArea.width / e.maxSeries / 2}, ${e.drawingArea.bottom + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.yOffset}), rotate(${e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation})`,
              absoluteIndex: r.absoluteIndex,
              content: r.text,
              textAnchor: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation > 0 ? "start" : e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation < 0 ? "end" : "middle",
              show: r && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && (h === 0 || h === e.timeLabels.length - 1) && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && t.selectedSerieIndex === h && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo && h % Math.floor((this.slicer.end - this.slicer.start) / e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.modulo) === 0
            })), void 0, !0)
          ]))), 128)) : (l(!0), i(I, { key: 1 }, m(e.timeLabels, (r, h) => (l(), i("g", {
            key: `time_label_${h}`
          }, [
            r && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && (h === 0 || h === e.timeLabels.length - 1) && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && t.selectedSerieIndex === h && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo && h % Math.floor((this.slicer.end - this.slicer.start) / e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.modulo) === 0 ? (l(), i("text", {
              key: 0,
              "text-anchor": e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation > 0 ? "start" : e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation < 0 ? "end" : "middle",
              "font-size": t.fontSizes.xAxis,
              fill: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.color,
              transform: `translate(${e.drawingArea.left + e.drawingArea.width / e.maxSeries * h + e.drawingArea.width / e.maxSeries / 2}, ${e.drawingArea.bottom + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.yOffset}), rotate(${e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation})`,
              style: {
                cursor: "pointer"
              },
              onClick: () => e.selectTimeLabel(r, h)
            }, k(r.text || ""), 9, Da)) : c("", !0)
          ]))), 128))
        ])) : c("", !0),
        f("g", null, [
          (l(!0), i(I, null, m(e.maxSeries, (r, h) => (l(), i("g", {
            key: `tooltip_trap_${h}`
          }, [
            f("rect", {
              "data-cy-trap": "",
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * h,
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: "transparent",
              onMouseenter: (n) => e.toggleTooltipVisibility(!0, h),
              onMouseleave: s[1] || (s[1] = (n) => e.toggleTooltipVisibility(!1)),
              onClick: (n) => e.selectX(h)
            }, null, 40, Ha)
          ]))), 128))
        ]),
        e.FINAL_CONFIG.chart.timeTag.show && (![null, void 0].includes(t.selectedSerieIndex) || ![null, void 0].includes(t.selectedMinimapIndex)) ? (l(), i("g", Ba, [
          (l(), i("foreignObject", {
            x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) - 100 + e.drawingArea.width / e.maxSeries / 2,
            y: e.drawingArea.bottom,
            width: "200",
            height: "40",
            style: { overflow: "visible !important" }
          }, [
            f("div", {
              class: "vue-ui-xy-time-tag",
              style: L(`width: fit-content;margin: 0 auto;text-align:center;padding:3px 12px;background:${e.FINAL_CONFIG.chart.timeTag.backgroundColor};color:${e.FINAL_CONFIG.chart.timeTag.color};font-size:${e.FINAL_CONFIG.chart.timeTag.fontSize}px`)
            }, k(e.timeLabels[(t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)].text || (t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)), 5)
          ], 8, Wa)),
          f("circle", {
            cx: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) + e.drawingArea.width / e.maxSeries / 2,
            cy: e.drawingArea.bottom,
            r: e.FINAL_CONFIG.chart.timeTag.circleMarker.radius,
            fill: e.FINAL_CONFIG.chart.timeTag.circleMarker.color
          }, null, 8, Ea)
        ])) : c("", !0)
      ])) : c("", !0),
      S(a.$slots, "svg", { svg: e.svg }, void 0, !0)
    ], 14, Qe)) : c("", !0),
    a.$slots.watermark ? (l(), i("div", Ya, [
      S(a.$slots, "watermark", H(B({ isPrinting: t.isPrinting || t.isImaging })), void 0, !0)
    ])) : c("", !0),
    e.isDataset ? c("", !0) : (l(), D(V, {
      key: 6,
      config: {
        type: "line",
        style: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          line: {
            axis: {
              color: e.FINAL_CONFIG.chart.grid.stroke
            },
            path: {
              color: e.FINAL_CONFIG.chart.grid.stroke,
              strokeWidth: 0.5
            }
          }
        }
      }
    }, null, 8, ["config"])),
    e.FINAL_CONFIG.chart.zoom.show && t.maxX > 6 && e.isDataset ? (l(), D(v, {
      ref: "chartSlicer",
      key: `slicer_${t.slicerStep}`,
      background: e.FINAL_CONFIG.chart.zoom.color,
      fontSize: e.FINAL_CONFIG.chart.zoom.fontSize,
      useResetSlot: e.FINAL_CONFIG.chart.zoom.useResetSlot,
      labelLeft: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[t.slicer.start],
      labelRight: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[t.slicer.end - 1],
      textColor: e.FINAL_CONFIG.chart.color,
      inputColor: e.FINAL_CONFIG.chart.zoom.color,
      selectColor: e.FINAL_CONFIG.chart.zoom.highlightColor,
      borderColor: e.FINAL_CONFIG.chart.backgroundColor,
      minimap: e.minimap,
      smoothMinimap: e.FINAL_CONFIG.chart.zoom.minimap.smooth,
      minimapSelectedColor: e.FINAL_CONFIG.chart.zoom.minimap.selectedColor,
      minimapSelectionRadius: e.FINAL_CONFIG.chart.zoom.minimap.selectionRadius,
      minimapLineColor: e.FINAL_CONFIG.chart.zoom.minimap.lineColor,
      minimapSelectedColorOpacity: e.FINAL_CONFIG.chart.zoom.minimap.selectedColorOpacity,
      minimapSelectedIndex: t.selectedSerieIndex,
      minimapIndicatorColor: e.FINAL_CONFIG.chart.zoom.minimap.indicatorColor,
      verticalHandles: e.FINAL_CONFIG.chart.zoom.minimap.verticalHandles,
      max: t.maxX,
      min: 0,
      valueStart: t.slicer.start,
      valueEnd: t.slicer.end,
      start: t.slicer.start,
      "onUpdate:start": s[2] || (s[2] = (r) => t.slicer.start = r),
      end: t.slicer.end,
      "onUpdate:end": s[3] || (s[3] = (r) => t.slicer.end = r),
      refreshStartPoint: e.FINAL_CONFIG.chart.zoom.startIndex !== null ? e.FINAL_CONFIG.chart.zoom.startIndex : 0,
      refreshEndPoint: e.FINAL_CONFIG.chart.zoom.endIndex !== null ? e.FINAL_CONFIG.chart.zoom.endIndex + 1 : Math.max(...o.dataset.map((r) => e.largestTriangleThreeBucketsArray({ data: r.series, threshold: e.FINAL_CONFIG.downsample.threshold }).length)),
      enableRangeHandles: e.FINAL_CONFIG.chart.zoom.enableRangeHandles,
      enableSelectionDrag: e.FINAL_CONFIG.chart.zoom.enableSelectionDrag,
      onReset: e.refreshSlicer,
      onTrapMouse: e.selectMinimapIndex
    }, {
      "reset-action": p(({ reset: r }) => [
        S(a.$slots, "reset-action", H(B({ reset: r })), void 0, !0)
      ]),
      _: 3
    }, 8, ["background", "fontSize", "useResetSlot", "labelLeft", "labelRight", "textColor", "inputColor", "selectColor", "borderColor", "minimap", "smoothMinimap", "minimapSelectedColor", "minimapSelectionRadius", "minimapLineColor", "minimapSelectedColorOpacity", "minimapSelectedIndex", "minimapIndicatorColor", "verticalHandles", "max", "valueStart", "valueEnd", "start", "end", "refreshStartPoint", "refreshEndPoint", "enableRangeHandles", "enableSelectionDrag", "onReset", "onTrapMouse"])) : c("", !0),
    e.FINAL_CONFIG.chart.legend.show ? (l(), i("div", {
      key: 8,
      ref: "chartLegend",
      class: "vue-ui-xy-legend",
      style: L(`font-size:${e.FINAL_CONFIG.chart.legend.fontSize}px`)
    }, [
      (l(!0), i(I, null, m(e.absoluteDataset, (r, h) => (l(), i("div", {
        key: `div_legend_item_${h}`,
        onClick: (n) => e.segregate(r),
        class: P({ "vue-ui-xy-legend-item": !0, "vue-ui-xy-legend-item-segregated": t.segregatedSeries.includes(r.id) })
      }, [
        t.icons[r.type] === "line" ? (l(), i("svg", Xa, [
          f("rect", {
            x: "0",
            y: "7.5",
            rx: "1.5",
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            "stroke-width": 0.5,
            height: "3",
            width: "20",
            fill: r.color
          }, null, 8, Ua),
          q(b, {
            plot: { x: 10, y: 9 },
            radius: 4,
            color: r.color,
            shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(r.shape) ? r.shape : "circle",
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            strokeWidth: 0.5
          }, null, 8, ["color", "shape", "stroke"])
        ])) : t.icons[r.type] === "bar" ? (l(), i("svg", Za, [
          t.icons[r.type] === "bar" && a.$slots.pattern ? (l(), i("rect", {
            key: 0,
            x: "0",
            y: "0",
            rx: "1",
            height: "40",
            width: "40",
            stroke: "none",
            fill: r.color
          }, null, 8, Ja)) : c("", !0),
          t.icons[r.type] === "bar" ? (l(), i("rect", {
            key: 1,
            x: "0",
            y: "0",
            rx: "1",
            height: "40",
            width: "40",
            stroke: "none",
            fill: a.$slots.pattern ? `url(#pattern_${t.uniqueId}_${r.slotAbsoluteIndex})` : r.color
          }, null, 8, Ka)) : c("", !0)
        ])) : (l(), i("svg", Qa, [
          q(b, {
            plot: { x: 6, y: 6 },
            radius: 5,
            color: r.color,
            shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(r.shape) ? r.shape : "circle"
          }, null, 8, ["color", "shape"])
        ])),
        f("span", {
          style: L(`color:${e.FINAL_CONFIG.chart.legend.color}`)
        }, k(r.name), 5)
      ], 10, qa))), 128))
    ], 4)) : (l(), i("div", ja, [
      S(a.$slots, "legend", { legend: e.absoluteDataset }, void 0, !0)
    ], 512)),
    a.$slots.source ? (l(), i("div", $a, [
      S(a.$slots, "source", {}, void 0, !0)
    ], 512)) : c("", !0),
    q(z, {
      show: t.mutableConfig.showTooltip && t.isTooltip,
      backgroundColor: e.FINAL_CONFIG.chart.tooltip.backgroundColor,
      color: e.FINAL_CONFIG.chart.tooltip.color,
      fontSize: e.FINAL_CONFIG.chart.tooltip.fontSize,
      borderRadius: e.FINAL_CONFIG.chart.tooltip.borderRadius,
      borderColor: e.FINAL_CONFIG.chart.tooltip.borderColor,
      borderWidth: e.FINAL_CONFIG.chart.tooltip.borderWidth,
      backgroundOpacity: e.FINAL_CONFIG.chart.tooltip.backgroundOpacity,
      position: e.FINAL_CONFIG.chart.tooltip.position,
      offsetY: e.FINAL_CONFIG.chart.tooltip.offsetY,
      parent: a.$refs.chart,
      content: e.tooltipContent,
      isFullscreen: t.isFullscreen,
      isCustom: e.FINAL_CONFIG.chart.tooltip.customFormat && typeof e.FINAL_CONFIG.chart.tooltip.customFormat == "function"
    }, {
      "tooltip-before": p(() => [
        S(a.$slots, "tooltip-before", H(B({ ...e.dataTooltipSlot })), void 0, !0)
      ]),
      "tooltip-after": p(() => [
        S(a.$slots, "tooltip-after", H(B({ ...e.dataTooltipSlot })), void 0, !0)
      ]),
      _: 3
    }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isFullscreen", "isCustom"]),
    e.isDataset ? (l(), D(M, {
      key: 11,
      hideDetails: "",
      config: {
        open: t.mutableConfig.showTable,
        maxHeight: 1e4,
        body: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          color: e.FINAL_CONFIG.chart.color
        },
        head: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          color: e.FINAL_CONFIG.chart.color
        }
      }
    }, {
      content: p(() => [
        f("div", {
          style: L(`${t.isPrinting ? "" : "max-height:400px"};overflow:auto;width:100%;margin-top:48px`)
        }, [
          f("div", er, [
            Ee(f("input", {
              type: "checkbox",
              "onUpdate:modelValue": s[4] || (s[4] = (r) => t.showSparklineTable = r)
            }, null, 512), [
              [Ye, t.showSparklineTable]
            ]),
            f("div", {
              onClick: s[5] || (s[5] = (r) => t.showSparklineTable = !t.showSparklineTable),
              style: { cursor: "pointer" }
            }, [
              q(O, {
                name: "chartLine",
                size: 20,
                stroke: e.FINAL_CONFIG.chart.color
              }, null, 8, ["stroke"])
            ])
          ]),
          t.showSparklineTable ? (l(), D(_, {
            key: `sparkline_${t.segregateStep}`,
            dataset: e.tableSparklineDataset,
            config: e.tableSparklineConfig
          }, null, 8, ["dataset", "config"])) : (l(), D(C, {
            key: `table_${t.tableStep}`,
            colNames: e.dataTable.colNames,
            head: e.dataTable.head,
            body: e.dataTable.body,
            config: e.dataTable.config,
            title: `${e.FINAL_CONFIG.chart.title.text}${e.FINAL_CONFIG.chart.title.subtitle.text ? ` : ${e.FINAL_CONFIG.chart.title.subtitle.text}` : ""}`,
            onClose: s[6] || (s[6] = (r) => t.mutableConfig.showTable = !1)
          }, {
            th: p(({ th: r }) => [
              f("div", { innerHTML: r }, null, 8, tr)
            ]),
            td: p(({ td: r }) => [
              qe(k(isNaN(Number(r)) ? r : e.dataLabel({
                p: e.FINAL_CONFIG.chart.labels.prefix,
                v: r,
                s: e.FINAL_CONFIG.chart.labels.suffix,
                r: e.FINAL_CONFIG.table.rounding
              })), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ], 4)
      ]),
      _: 1
    }, 8, ["config"])) : c("", !0)
  ], 46, Je);
}
const br = /* @__PURE__ */ Xe(Ze, [["render", ar], ["__scopeId", "data-v-7d74eded"]]);
export {
  br as default
};
