import { useCssVars as De, ref as o, computed as r, watch as R, onMounted as Te, onBeforeUnmount as ze, onUpdated as Ie, nextTick as ne, openBlock as v, createElementBlock as c, createElementVNode as d, normalizeStyle as $, createVNode as Pe, renderSlot as Ae, createCommentVNode as x, unref as G, Fragment as ie, renderList as oe, normalizeClass as L, withDirectives as ue, vModelText as re, toDisplayString as se, pushScopeId as Fe, popScopeId as He } from "vue";
import Ve from "./BaseIcon-DIxHp0nP.js";
import { t as We, u as Xe } from "./useResponsive-CoxXLe23.js";
import { c as Ue, R as de, Q as ve, X as Oe, G as ce } from "./index-CsThtcFA.js";
import { _ as Ge } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const me = (l) => (Fe("data-v-74b2f684"), l = l(), He(), l), je = {
  class: "vue-data-ui-slicer-labels",
  style: { position: "relative", "z-index": "1", "pointer-events": "none" }
}, Ze = {
  key: 0,
  style: { width: "100%", position: "relative" }
}, qe = {
  key: 0,
  class: "minimap",
  style: { width: "100%" }
}, Qe = ["xmlns", "viewBox"], Je = ["id"], Ke = ["stop-color"], Ye = /* @__PURE__ */ me(() => /* @__PURE__ */ d("stop", {
  offset: "100%",
  "stop-color": "transparent"
}, null, -1)), _e = ["d", "stroke"], et = ["x", "width", "height", "fill", "rx"], tt = ["d", "fill"], lt = ["x", "width", "height", "rx", "fill"], at = ["x", "width", "height", "fill", "rx"], nt = ["d", "fill"], it = ["d", "stroke"], ot = ["cx", "cy", "stroke", "fill"], ut = ["cx", "cy", "stroke", "fill"], rt = ["x1", "x2", "y2", "stroke"], st = ["x", "height", "width", "onMouseenter"], dt = /* @__PURE__ */ me(() => /* @__PURE__ */ d("div", { class: "slider-track" }, null, -1)), vt = ["min", "max"], ct = ["min", "max"], mt = {
  __name: "Slicer",
  props: {
    background: {
      type: String,
      default: "#FFFFFF"
    },
    borderColor: {
      type: String,
      default: "#FFFFFF"
    },
    fontSize: {
      type: Number,
      default: 14
    },
    labelLeft: {
      type: String,
      default: ""
    },
    labelRight: {
      type: String,
      default: ""
    },
    textColor: {
      type: String,
      default: "#1A1A1A"
    },
    inputColor: {
      type: String,
      default: "#1A1A1A"
    },
    max: {
      type: Number,
      default: 0
    },
    min: {
      type: Number,
      default: 0
    },
    selectColor: {
      type: String,
      default: "#4A4A4A"
    },
    useResetSlot: {
      type: Boolean,
      default: !1
    },
    valueStart: {
      type: [Number, String],
      default: 0
    },
    valueEnd: {
      type: [Number, String],
      default: 0
    },
    minimap: {
      type: Array,
      default: []
    },
    smoothMinimap: {
      type: Boolean,
      default: !1
    },
    minimapSelectedColor: {
      type: String,
      default: "#1f77b4"
    },
    minimapSelectionRadius: {
      type: Number,
      default: 12
    },
    minimapLineColor: {
      type: String,
      default: "#2D353C"
    },
    minimapSelectedColorOpacity: {
      type: Number,
      default: 0.2
    },
    minimapSelectedIndex: {
      type: Number,
      default: null
    },
    minimapIndicatorColor: {
      type: String,
      default: "#2D353C"
    },
    refreshStartPoint: {
      type: Number,
      default: 0
    },
    refreshEndPoint: {
      type: Number,
      default: null
    },
    enableRangeHandles: {
      type: Boolean,
      default: !1
    },
    enableSelectionDrag: {
      type: Boolean,
      default: !0
    },
    verticalHandles: {
      type: Boolean,
      default: !1
    }
  },
  emits: ["update:start", "update:end", "reset", "trapMouse"],
  setup(l, { expose: he, emit: b }) {
    const e = l;
    De((t) => ({
      ab4e97d8: ge.value,
      "424e3c88": w.value,
      "1c59780e": xe.value,
      "22837db8": l.selectColor,
      "0bd24c46": pe.value
    }));
    const f = o(null), u = o(e.min), s = o(e.max), y = r(() => !!e.minimap.length), D = o(Ue()), fe = r(() => e.refreshEndPoint === null ? e.max : e.refreshEndPoint), S = r(() => {
      const t = e.max - e.min, a = (u.value - e.min) / t * 100, n = (s.value - e.min) / t * 100;
      return {
        left: `${a}%`,
        width: `${n - a}%`,
        background: e.selectColor,
        tooltipLeft: `calc(${a}% - ${j.value ? 0 : U.value / 2}px)`,
        tooltipRight: `calc(${n}% - ${Z.value ? B.value : B.value / 2}px)`,
        arrowLeft: !j.value,
        arrowRight: !Z.value
      };
    }), j = r(() => f.value ? f.value.getBoundingClientRect().width * ((u.value - e.min) / (e.max - e.min)) - U.value / 2 < 0 : !1), Z = r(() => f.value ? f.value.getBoundingClientRect().width * ((s.value - e.min) / (e.max - e.min)) + B.value / 2 > f.value.getBoundingClientRect().width : !1), ge = r(() => e.inputColor), pe = r(() => e.background), xe = r(() => `${e.selectColor}33`), w = r(() => e.borderColor), q = r(() => {
      let t = [];
      for (let a = 0; a < e.minimap.length; a += 1)
        t.push(a);
      return t;
    });
    function Q() {
      b("reset");
    }
    function be() {
      Number(u.value) > Number(s.value) - 1 && (u.value = Number(s.value) - 1), b("update:start", Number(u.value));
    }
    function ye() {
      Number(s.value) < Number(u.value) + 1 && (s.value = Number(u.value) + 1), b("update:end", Number(s.value));
    }
    R(
      () => e.min,
      (t) => {
        Number(u.value) < Number(t) && (u.value = Number(t)), Number(s.value) < Number(t) && (s.value = Number(t));
      }
    ), R(
      () => e.max,
      (t) => {
        Number(u.value) > Number(t) && (u.value = Number(t)), Number(s.value) > Number(t) && (s.value = Number(t));
      }
    );
    const T = o(null), i = o({
      width: 1,
      height: 1
    }), E = o(null);
    Te(() => {
      if (y.value) {
        const t = We(() => {
          const { width: a, height: n } = Xe({
            chart: T.value
          });
          i.value.width = a, i.value.height = n - 47;
        });
        E.value = new ResizeObserver(t), E.value.observe(T.value);
      }
    }), ze(() => {
      E.value && E.value.disconnect();
    });
    const m = r(() => e.minimap.length ? i.value.width / e.minimap.length : 0), g = r(() => {
      if (!e.minimap.length) return [];
      const t = Math.max(...e.minimap), a = Math.min(...e.minimap) - 10, n = t - (a > 0 ? 0 : a), h = e.minimap.map((Le, Ee) => {
        const Be = Le - a;
        return {
          x: i.value.width / e.minimap.length * Ee + m.value / 2,
          y: i.value.height - Be / n * (i.value.height * 0.9)
        };
      }), k = e.smoothMinimap ? de(h) : ve(h), O = [...h].slice(e.valueStart, e.valueEnd), Re = e.smoothMinimap ? de(O) : ve(O);
      return {
        fullSet: k,
        selectionSet: Re,
        sliced: O,
        firstPlot: h[e.valueStart],
        lastPlot: h[e.valueEnd - 1]
      };
    }), p = r(() => ({
      x: m.value * u.value + m.value / 2,
      width: i.value.width * ((s.value - u.value) / e.max) - m.value
    }));
    r(() => ({
      left: 0,
      color: e.textColor,
      fontSize: `${e.fontSize}px`,
      top: y.value ? "28px" : "-28px",
      pointerEvents: "none"
    })), r(() => ({
      right: 0,
      color: e.textColor,
      fontSize: `${e.fontSize}px`,
      top: y.value ? "28px" : "-28px",
      direction: "rtl",
      pointerEvents: "none"
    }));
    const M = o(e.minimapSelectedIndex);
    R(() => e.minimapSelectedIndex, (t) => {
      M.value = t + e.valueStart;
    }, { immediate: !0 });
    function Se(t) {
      M.value = t, t >= e.valueStart && t < e.valueEnd && b("trapMouse", t - e.valueStart);
    }
    const we = o(0), z = o(null), I = o(null);
    function P(t) {
      u.value = t, z.value && (z.value.value = t), b("update:start", Number(u.value));
    }
    function A(t) {
      s.value = t, I.value && (I.value.value = t), b("update:end", Number(s.value));
    }
    const F = r(() => e.valueEnd - e.valueStart), H = o(!1);
    let V = o(null);
    const ke = r(() => f.value ? (f.value.getBoundingClientRect().width - 48) / (e.max - e.min) : 20), Ce = r(() => (f.value.getBoundingClientRect().width - 48) / (e.max - e.min) * F.value), Ne = o(2.5), J = r(() => {
      const t = f.value.getBoundingClientRect().width - 48;
      return Math.ceil((e.max - e.min) / ((t - Ce.value) / Ne.value));
    }), K = (t) => {
      if (N.value = !0, !e.enableSelectionDrag)
        return;
      const a = t.type === "touchstart";
      if ((a ? t.targetTouches[0].target : t.target).classList.contains("range-handle"))
        return;
      H.value = !0, V.value = a ? t.targetTouches[0].clientX : t.clientX;
      const h = a ? $e : Y, k = a ? Me : ee;
      window.addEventListener(a ? "touchmove" : "mousemove", h, { passive: !1 }), window.addEventListener(a ? "touchend" : "mouseup", k);
    };
    function Y(t) {
      _(t.clientX);
    }
    function $e(t) {
      f.value.contains(t.target) && (t.target.classList.contains("range-handle") || (t.preventDefault(), _(t.targetTouches[0].clientX)));
    }
    function _(t) {
      if (!H.value) return;
      const a = t - V.value;
      if (Math.abs(a) > ke.value) {
        if (a > 0) {
          if (Number(s.value) + 1 <= e.max) {
            const n = Math.min(e.max, Number(s.value) + J.value);
            A(n), P(n - F.value);
          }
        } else if (Number(u.value) - 1 >= e.min) {
          const n = Math.max(0, Number(u.value) - J.value);
          P(n), A(n + F.value);
        }
        V.value = t;
      }
    }
    function ee() {
      te("mousemove", "mouseup");
    }
    function Me() {
      te("touchmove", "touchend");
    }
    function te(t, a) {
      H.value = !1, window.removeEventListener(t, Y), window.removeEventListener(a, ee);
    }
    const C = o(!1), W = o(null), X = o(null), U = o(1), B = o(1), N = o(!1);
    function le() {
      W.value && (U.value = W.value.getBoundingClientRect().width);
    }
    function ae() {
      X.value && (B.value = X.value.getBoundingClientRect().width);
    }
    return Ie(() => {
      le(), ae();
    }), R(() => e.labelLeft, () => {
      ne(le);
    }, { deep: !0 }), R(() => e.labelRight, () => {
      ne(ae);
    }, { deep: !0 }), he({
      setStartValue: P,
      setEndValue: A
    }), (t, a) => (v(), c("div", {
      "data-html2canvas-ignore": "",
      style: { padding: "0 24px" },
      class: "vue-data-ui-zoom",
      ref_key: "zoomWrapper",
      ref: f,
      onMousedown: K,
      onTouchstart: K,
      onTouchend: a[9] || (a[9] = (n) => N.value = !1)
    }, [
      d("div", je, [
        l.valueStart !== l.refreshStartPoint || l.valueEnd !== fe.value ? (v(), c("div", Ze, [
          l.useResetSlot ? Ae(t.$slots, "reset-action", {
            key: 1,
            reset: Q
          }, void 0, !0) : (v(), c("button", {
            key: 0,
            "data-cy-reset": "",
            tabindex: "0",
            role: "button",
            class: "vue-data-ui-refresh-button",
            style: $({
              top: y.value ? "36px" : "-16px",
              pointerEvents: "all !important"
            }),
            onClick: Q
          }, [
            Pe(Ve, {
              name: "refresh",
              stroke: l.textColor
            }, null, 8, ["stroke"])
          ], 4))
        ])) : x("", !0)
      ]),
      d("div", {
        class: "double-range-slider",
        ref_key: "minimapWrapper",
        ref: T,
        style: { "z-index": "0" },
        onMouseenter: a[7] || (a[7] = (n) => N.value = !0),
        onMouseleave: a[8] || (a[8] = (n) => N.value = !1)
      }, [
        y.value ? (v(), c("div", qe, [
          (v(), c("svg", {
            xmlns: G(Oe),
            viewBox: `0 0 ${i.value.width < 0 ? 0 : i.value.width} ${i.value.height < 0 ? 0 : i.value.height}`
          }, [
            d("defs", null, [
              d("linearGradient", {
                id: D.value,
                x1: "0%",
                y1: "0%",
                x2: "0%",
                y2: "100%"
              }, [
                d("stop", {
                  offset: "0%",
                  "stop-color": `${l.minimapLineColor}50`
                }, null, 8, Ke),
                Ye
              ], 8, Je)
            ]),
            d("path", {
              d: `M${g.value.fullSet}`,
              stroke: `${l.minimapLineColor}`,
              fill: "none",
              "stroke-width": "1",
              "stroke-linecap": "round",
              "stroke-linejoin": "round",
              style: { opacity: "1" }
            }, null, 8, _e),
            d("rect", {
              x: p.value.x,
              width: p.value.width < 0 ? 0 : p.value.width,
              height: Math.max(i.value.height, 0),
              y: 0,
              fill: w.value,
              rx: l.minimapSelectionRadius,
              stroke: "none"
            }, null, 8, et),
            d("path", {
              d: `M${m.value / 2},${Math.max(i.value.height, 0)} ${g.value.fullSet} L${i.value.width - m.value / 2},${Math.max(i.value.height, 0)}Z`,
              fill: `url(#${D.value})`,
              stroke: "none",
              style: { opacity: "1" }
            }, null, 8, tt),
            d("rect", {
              x: p.value.x,
              width: p.value.width < 0 ? 0 : p.value.width,
              height: Math.max(i.value.height, 0),
              y: 0,
              rx: l.minimapSelectionRadius,
              fill: w.value
            }, null, 8, lt),
            d("rect", {
              x: p.value.x,
              width: p.value.width < 0 ? 0 : p.value.width,
              height: Math.max(i.value.height, 0),
              y: 0,
              fill: l.minimapSelectedColor,
              rx: l.minimapSelectionRadius,
              style: $({
                opacity: l.minimapSelectedColorOpacity
              })
            }, null, 12, at),
            d("path", {
              d: `M${g.value.sliced[0].x},${Math.max(i.value.height, 0)} ${g.value.selectionSet} L${g.value.sliced.at(-1).x},${Math.max(i.value.height, 0)}Z`,
              fill: `url(#${D.value})`,
              stroke: "none",
              style: { opacity: "1" }
            }, null, 8, nt),
            d("path", {
              d: `M ${g.value.selectionSet}`,
              stroke: `${l.minimapLineColor}`,
              fill: "transparent",
              "stroke-width": "2",
              "stroke-linecap": "round",
              "stroke-linejoin": "round"
            }, null, 8, it),
            d("circle", {
              cx: g.value.firstPlot.x,
              cy: g.value.firstPlot.y,
              "stroke-width": "0.5",
              stroke: w.value,
              r: "3",
              fill: l.minimapLineColor
            }, null, 8, ot),
            d("circle", {
              cx: g.value.lastPlot.x,
              cy: g.value.lastPlot.y,
              "stroke-width": "0.5",
              stroke: w.value,
              r: "3",
              fill: l.minimapLineColor
            }, null, 8, ut),
            M.value !== null ? (v(!0), c(ie, { key: 0 }, oe(q.value, (n, h) => (v(), c("g", null, [
              M.value === n && n >= l.valueStart && n < l.valueEnd ? (v(), c("line", {
                key: 0,
                x1: m.value * h + m.value / 2,
                x2: m.value * h + m.value / 2,
                y1: 0,
                y2: Math.max(i.value.height, 0),
                stroke: l.minimapIndicatorColor,
                "stroke-linecap": "round",
                "stroke-dasharray": "2",
                "stroke-width": "1"
              }, null, 8, rt)) : x("", !0)
            ]))), 256)) : x("", !0),
            (v(!0), c(ie, null, oe(q.value, (n, h) => (v(), c("rect", {
              x: m.value * h,
              y: 0,
              height: Math.max(i.value.height, 0),
              width: m.value < 0 ? 0 : m.value,
              fill: "transparent",
              style: $([{ "pointer-events": "all !important" }, {
                cursor: n >= l.valueStart && n < l.valueEnd && l.enableSelectionDrag ? C.value ? "grabbing" : "grab" : "default"
              }]),
              onMousedown: a[0] || (a[0] = (k) => C.value = !0),
              onMouseup: a[1] || (a[1] = (k) => C.value = !1),
              onMouseenter: (k) => Se(n),
              onMouseleave: a[2] || (a[2] = (k) => {
                M.value = null, b("trapMouse", null);
              })
            }, null, 44, st))), 256))
          ], 8, Qe))
        ])) : x("", !0),
        dt,
        d("div", {
          class: L({
            "range-highlight": !0,
            move: l.enableSelectionDrag
          }),
          onMousedown: a[3] || (a[3] = (n) => C.value = !0),
          onMouseup: a[4] || (a[4] = (n) => C.value = !1),
          style: $({
            ...S.value,
            cursor: C.value ? "grabbing" : "grab"
          })
        }, null, 38),
        l.enableRangeHandles ? ue((v(), c("input", {
          ref_key: "rangeStart",
          ref: z,
          key: `range-min${we.value}`,
          type: "range",
          class: L({ "range-left": !0, "range-handle": !0, "range-minimap": y.value && l.verticalHandles }),
          min: l.min,
          max: l.max,
          "onUpdate:modelValue": a[5] || (a[5] = (n) => u.value = n),
          onInput: be
        }, null, 42, vt)), [
          [re, u.value]
        ]) : x("", !0),
        l.enableRangeHandles ? ue((v(), c("input", {
          key: 2,
          ref_key: "rangeEnd",
          ref: I,
          type: "range",
          class: L({ "range-right": !0, "range-handle": !0, "range-minimap": y.value && l.verticalHandles }),
          min: l.min,
          max: l.max,
          "onUpdate:modelValue": a[6] || (a[6] = (n) => s.value = n),
          onInput: ye
        }, null, 42, ct)), [
          [re, s.value]
        ]) : x("", !0),
        l.labelLeft ? (v(), c("div", {
          key: 3,
          ref_key: "tooltipLeft",
          ref: W,
          class: L({
            "range-tooltip": !0,
            "range-tooltip-visible": N.value,
            "range-tooltip-arrow": S.value.arrowLeft && !l.verticalHandles,
            "range-tooltip-arrow-left": !S.value.arrowLeft && !l.verticalHandles
          }),
          style: $({
            left: S.value.tooltipLeft,
            color: G(ce)(l.selectColor),
            backgroundColor: l.selectColor,
            border: `1px solid ${w.value}`
          })
        }, se(l.labelLeft), 7)) : x("", !0),
        l.labelRight ? (v(), c("div", {
          key: 4,
          ref_key: "tooltipRight",
          ref: X,
          class: L({
            "range-tooltip": !0,
            "range-tooltip-visible": N.value,
            "range-tooltip-arrow": S.value.arrowRight && !l.verticalHandles,
            "range-tooltip-arrow-right": !S.value.arrowRight && !l.verticalHandles
          }),
          style: $({
            left: S.value.tooltipRight,
            color: G(ce)(l.selectColor),
            backgroundColor: l.selectColor,
            border: `1px solid ${w.value}`
          })
        }, se(l.labelRight), 7)) : x("", !0)
      ], 544)
    ], 544));
  }
}, bt = /* @__PURE__ */ Ge(mt, [["__scopeId", "data-v-74b2f684"]]);
export {
  bt as S
};
